DEFINT A-Z
DECLARE FUNCTION CalcEQU$ (xxx$)
DECLARE FUNCTION RemoveTrash$ (txt$)
DECLARE FUNCTION CountStr% (txx$, sort$)
DECLARE FUNCTION FixVal16$ (flump$)
DECLARE FUNCTION GetAdr& (tmp$)
DECLARE FUNCTION GetTrueVal32& (invar$)
DECLARE FUNCTION GetTrueVal16& (flump$)
DECLARE FUNCTION GetByteValue$ (txt$)
DECLARE FUNCTION GetVal16$ (flump$)
DECLARE FUNCTION GetVal32$ (invar$)
DECLARE FUNCTION CheckEQU$ (tsxx$)
DECLARE FUNCTION ValidCP2Reg$ (txt$)
DECLARE FUNCTION ValidFReg$ (txt$)
DECLARE FUNCTION GetDec& (tmp$)
DECLARE FUNCTION FromBin% (txt$)
DECLARE FUNCTION FromBin32& (txt$)
DECLARE FUNCTION ValidReg$ (txt$)
DECLARE FUNCTION GetValue16$ (tmp$)
DECLARE FUNCTION GetValue32$ (invar$)
DECLARE FUNCTION shr# (var&, steps%)
DECLARE FUNCTION ToBin8$ (byte&)
DECLARE FUNCTION ToBin16$ (word&)
DECLARE FUNCTION ToBin32$ (word&)
DECLARE FUNCTION shl# (var&, steps%)
DECLARE FUNCTION GetBranchVal$ (num&)
DECLARE FUNCTION GetBranchValBREAK$ (num&)
DECLARE SUB GenerateBinary ()
DECLARE SUB SetStartVars ()
DECLARE SUB ShowSyntax (txt$)
DECLARE SUB GetSyntax ()
DECLARE SUB HandleDirective ()
DECLARE SUB IncludeBin ()
DECLARE SUB InsertBlock ()
DECLARE SUB WordBlock ()
DECLARE SUB HalfBlock ()
DECLARE SUB ByteBlock ()
DECLARE SUB PseudoType6 (xxx$)
DECLARE SUB PseudoType5 (xxx$)
DECLARE SUB PseudoType4 (xxx$)
DECLARE SUB PseudoType3 (xxx$)
DECLARE SUB PseudoType2 (xxx$)
DECLARE SUB PseudoType1 (xxx$)
DECLARE SUB Type32 (xxx$)
DECLARE SUB Type31 (xxx$)
DECLARE SUB Type30 (xxx$)
DECLARE SUB Type29 (xxx$)
DECLARE SUB Type28 (xxx$)
DECLARE SUB Type27 (xxx$)
DECLARE SUB Type26 (xxx$)
DECLARE SUB Type24 (xxx$)
DECLARE SUB Type25 (xxx$)
DECLARE SUB Type23 (xxx$)
DECLARE SUB Type22 (xxx$)
DECLARE SUB Type21 (xxx$)
DECLARE SUB Type20 (xxx$)
DECLARE SUB Type19 (xxx$)
DECLARE SUB Type18 (xxx$)
DECLARE SUB Type17 (xxx$)
DECLARE SUB Type16 (xxx$)
DECLARE SUB Type15 (xxx$)
DECLARE SUB Type14 (xxx$)
DECLARE SUB Type13 (xxx$)
DECLARE SUB Type12 (xxx$)
DECLARE SUB Type11 (xxx$)
DECLARE SUB Type10 (xxx$)
DECLARE SUB Type9 (xxx$)
DECLARE SUB Type8 (xxx$)
DECLARE SUB Type7 (xxx$)
DECLARE SUB Type6 (xxx$)
DECLARE SUB Type5 (xxx$)
DECLARE SUB Type4 (xxx$)
DECLARE SUB Type3 (xxx$)
DECLARE SUB Type2 (xxx$)
DECLARE SUB Type1 (xxx$)
DECLARE SUB Type0 ()
DECLARE SUB SplitParam (some$, trams%)
DECLARE SUB ErrorCode (num%, txt$)

'ON ERROR GOTO ErrorMessage

'
'dim satser
'
  DIM SHARED Version$
  DIM SHARED InFile$, TempFile$, TempFile2$, OutFile$, IncludeFile$, Syntax$
  DIM SHARED LineCount&, IncludeCnt&           'hller koll p vilken rad man e p :)
  DIM SHARED BootCode1$
  DIM SHARED rad$, param$, inst$
  DIM SHARED parameter$(10), ParameterCNT     'parametrar till asm instruktion
  DIM SHARED ParamErr, known, UnknownInstr
  DIM SHARED Reg$(&H1F), Reg2$(&H1F), Reg3$(&H1F), Reg4$(&H1F)
  DIM SHARED FReg$(&H1F), FReg2$(&H1F), CP2Reg$(&H1F), CP2BReg$(&H1F)
  DIM SHARED MainCode&                        'pekar var jag e i filen
  DIM SHARED Label$(1000), LabelCnt&          'labels i koden som man kan hoppa till ! :)
  DIM SHARED EQU$(200), EQUCnt
  DIM SHARED MBitVal, NoHeader
  DIM SHARED BadFlag                          '=1 om fel uppsttt vid kompilering
  DIM SHARED ErrCnt                           'error counter
  DIM SHARED UnSuppCnt, NonExistLabelCnt      'unsupported opcodes counter
  DIM SHARED OrgAdr&, OrgAdrValue$            'contains value of .org
  DIM SHARED ByteSwap, ByteRad$               '1=true
  DIM SHARED OkFileWrite                      '1 = rtt antal bytes skrivna
  DIM SHARED LabelPosCounter                  'vart i binaryn aktuell label finns
  DIM SHARED OpcodePosCnt                     'en till counter

  DIM SHARED BootTitle$, BootManufact$, BootCartID$, BootCountry$, BootCode$
  DIM SHARED ErrorSpaces$, MaxErrors
  DIM SHARED CheckEQUTimes          'antal gnger man kr checkequ p varje rad
  DIM SHARED KeepFile, DebugMode, AlignSize


'
'startup variabler
'
SetStartVars
  

  Syntax$ = COMMAND$



  TempFile$ = "N64ASM.TMP"
  TempFile2$ = "N64ASM.TM2"

  '-----------------defaults----------------------------------
  ByteSwap = 0                'no byteswapping
  KeepFile = 0                'delete file if error occurs
  NoHeader = 1                'skip header generation
  MaxErrors = 200             '100 errors then stop
  CheckEQUTimes = 2           'check for equ 2 times/line only
  DebugMode = 0               '0 = release version
  AlignSize = 4               '2,4 eller 8

  ErrorSpaces$ = " "
  rad$ = ""

'
'program start
'
PRINT Version$
PRINT

   IF Syntax$ = "" THEN
      ShowSyntax ""
   ELSE
     '
     PRINT " Reading and parsing "; InFile$; " .."
     'plockar ven ut .noheader och .org direktiv och erstter EQU's med
     'respektive kod,  kollar om man ska byteswappa  ordnar med include filer
     '
     GetSyntax
   END IF




   IF InFile$ <> "" THEN
      ErrFile$ = InFile$
      OPEN ErrFile$ FOR BINARY AS #1
          IF LOF(1) = 0 THEN
             PRINT "  "; InFile$; " does not exist!"
             CLOSE #1
             IF DebugMode = 0 THEN KILL InFile$
             END
          END IF
      CLOSE #1
   ELSE
      ShowSyntax ""
   END IF

ErrFile$ = TempFile2$
OPEN ErrFile$ FOR BINARY AS #2
   tmp# = LOF(2)
CLOSE #2
IF DebugMode = 0 THEN KILL TempFile2$




   ErrFile$ = TempFile$
   OPEN ErrFile$ FOR BINARY AS #2
   CLOSE #2
   IF DebugMode = 0 THEN KILL TempFile$
  
   ErrFile$ = InFile$
   OPEN ErrFile$ FOR INPUT AS #1

   ErrFile$ = TempFile$
   OPEN ErrFile$ FOR OUTPUT AS #2

   DO WHILE NOT EOF(1)
      skipme = 0
      LINE INPUT #1, text$
      LineCount& = LineCount& + 1
      tmp1$ = LTRIM$(STR$(LineCount&))
      rad$ = tmp1$
      text$ = LTRIM$(RTRIM$(text$))
      temp = INSTR(text$, ";")
      IF temp THEN text$ = RTRIM$(LEFT$(text$, temp - 1))
      IF text$ <> "" THEN
         text$ = RemoveTrash(text$)
         IF text$ <> "" THEN
            search = INSTR(text$, ":")
            searchB = INSTR(text$ + " ", " ")
            IF search > 0 AND searchB > search THEN
               labeln$ = LEFT$(text$, search)
               'hittar en label i brjan av raden, plockar ut  skriver
               text2$ = LTRIM$(RTRIM$(MID$(text$, search + 1)))
               Label$(LabelCnt&) = labeln$ + STR$(LabelPosCounter)
               LabelCnt& = LabelCnt& + 1
               IF text2$ <> "" THEN  'skriver ev koder efter label:
                  LabelPosCounter = LabelPosCounter + 1
                  PRINT #2, tmp1$ + " " + text2$
               END IF
               skipme = 1
            END IF

            text$ = LTRIM$(RTRIM$(text$))
            flsk = INSTR(text$, " ")
            IF flsk > 0 THEN
               textT$ = UCASE$(LEFT$(text$, flsk - 1))
               textR$ = LTRIM$(MID$(text$, flsk + 1))
               FOR kaka = 1 TO CheckEQUTimes
                   textR$ = CheckEQU(textR$)
               NEXT kaka
               textR$ = CalcEQU(textR$)
            ELSE
               textT$ = UCASE$(text$)
            END IF
            SELECT CASE textT$
                CASE ".BYTESWAP":
                   ByteRad$ = LTRIM$(STR$(LineCount&))
                   ByteSwap = -1: skipme = 1
                   textR$ = UCASE$(textR$)
                   SELECT CASE textR$
                      CASE "YES", "ON", "TRUE": ByteSwap = 1
                      CASE "NO", "OFF", "FALSE": ByteSwap = 0
                   END SELECT
                CASE ".NOCHANGEBYTES":
                   ByteSwap = 0: skipme = 1
                CASE ".CHANGEBYTES":
                   ByteSwap = 1: skipme = 1
                CASE "ORG", ".ORG":
                   OrgAdr& = GetDec(textR$): skipme = 1
                   OrgAdrValue$ = GetVal32(textR$)
                   
                CASE "INCLUDE", ".INCLUDE": 'there are a file to include here..
                   skipme = 1: tramsa$ = LTRIM$(RTRIM$(textR$))
                   IF LEFT$(tramsa$, 1) = CHR$(34) THEN    'text strng
                      IF RIGHT$(tramsa$, 1) = CHR$(34) THEN    'text strng
                         tmp1 = LEN(tramsa$)
                         IncludeFile$ = UCASE$(MID$(tramsa$, 2, tmp1 - 2))
                      ELSE
                         PRINT " ("; rad$; ") Ending " + CHR$(34) + " is missing."
                      END IF
                   ELSE
                      IncludeFile$ = UCASE$(tramsa$)
                   END IF
                   'IncludeFile$ innehller nu filnamnet p includefilen
                   ErrFile$ = IncludeFile$
                   OPEN ErrFile$ FOR BINARY AS #5
                       skabb# = LOF(5)
                   CLOSE #5
                   IF skabb# = 0 THEN   'filen finns inte
                      rad$ = LTRIM$(STR$(LineCount&))
                      ErrorCode 10, IncludeFile$
                      IF DebugMode = 0 THEN KILL IncludeFile$
                   ELSE
                      PRINT "  Including "; IncludeFile$; " ... ";
                      ErrFile$ = IncludeFile$
                      OPEN ErrFile$ FOR INPUT AS #5
                         IncludeCnt& = 0
                         DO
                            LINE INPUT #5, krass$: IncludeCnt& = IncludeCnt& + 1: skipme2 = 0
                            temp = INSTR(krass$, ";")
                            IF temp THEN krass$ = RTRIM$(LEFT$(krass$, temp - 1))
                            krass$ = LTRIM$(RTRIM$(krass$))

                            temp = INSTR(krass$, " ")
                            IF temp THEN
                               txtXX$ = LEFT$(krass$, temp - 1)
                               txtYY$ = LTRIM$(MID$(krass$, temp + 1))
                            END IF
                            IF txtXX$ <> "" THEN    'kollar om det r en EQU
                               IF LEFT$(txtYY$, 4) = "EQU " THEN 'hittad
                                  equname$ = txtXX$
                                  equvalue$ = MID$(txtYY$, 5): skipme2 = 1
                                  FOR kaka = 1 TO CheckEQUTimes
                                      equvalue$ = CheckEQU(equvalue$) 'erstter andra equ's
                                  NEXT kaka
                                  equvalue$ = CalcEQU(equvalue$)
                                  IF equvalue$ <> "" THEN
                                     EQU$(EQUCnt) = UCASE$(equname$) + " " + equvalue$
                                     EQUCnt = EQUCnt + 1
                                  END IF
                               END IF
                            END IF
                            IF krass$ <> "" THEN  'om det r nn kod kvar
                               'skriver hela includefilen till .tmp filen
                               IF skipme2 = 0 THEN
                                  FOR kaka = 1 TO CheckEQUTimes
                                      krass$ = CheckEQU(krass$)
                                  NEXT kaka
                                  krass$ = CalcEQU(krass$)
                                  LabelPosCounter = LabelPosCounter + 1
                                  PRINT #2, LTRIM$(STR$(IncludeCnt&)); "_"; IncludeFile$; " "; krass$
                               END IF
                            END IF
                         LOOP WHILE NOT EOF(5)
                      CLOSE #5
                      PRINT "Done."
                   END IF
                CASE ".TITLE", ".ROMNAME":
                   BootTitle$ = GetByteValue(textR$): skipme = 1: NoHeader = 0
                CASE ".MANUFACTURER":
                   BootManufact$ = GetVal16(textR$): skipme = 1: NoHeader = 0
                   BootManufact$ = RIGHT$(BootManufact$, 1)  'tar lga byten bara
                CASE ".CARTID", ".ROMID":
                   BootCartID$ = GetByteValue(textR$): skipme = 1: NoHeader = 0
                CASE ".COUNTRY", ".ROMCOUNTRY":
                   BootCountry$ = GetVal16(textR$): skipme = 1: NoHeader = 0
                   BootCountry$ = RIGHT$(BootCountry$, 1)  'tar lga byten bara
                CASE ".BOOTCODE":
                   BootCode$ = GetByteValue(textR$): skipme = 1: NoHeader = 0
                CASE ".MBIT":
                   MBitVal = GetDec(textR$): skipme = 1
                CASE ".NOHEADER":
                   skipme = 1: NoHeader = 1
                CASE ".HEADER":
                   skipme = 1: NoHeader = 0
                CASE ".V64HEADER":
                   skipme = 1: NoHeader = 0
                CASE ".ALIGN2":
                   skipme = 1: AlignSize = 2
                CASE ".ALIGN4":
                   skipme = 1: AlignSize = 4
                CASE ".ALIGN8":
                   skipme = 1: AlignSize = 8
                CASE ".ALIGN":
                   skipme = 1
                   SELECT CASE textR$
                      CASE "2", "4", "8": AlignSize = GetDec(textR$)
                      CASE ELSE: ErrorCode 14, textR$
                   END SELECT
            END SELECT
            
            IF textT$ <> "" THEN    'kollar om det r en EQU
               trump$ = UCASE$(LEFT$(textR$, 3))
               IF trump$ = "EQU" THEN  'hittad
                   equname$ = textT$: equvalue$ = LTRIM$(MID$(textR$, 5)): skipme = 1
                   
                   'erstter andra EQU's i denna EQU med resp. kod
                   FOR kaka = 1 TO CheckEQUTimes
                       equvalue$ = CheckEQU(equvalue$)
                   NEXT kaka
                   equvalue$ = CalcEQU(equvalue$)
                   IF equvalue$ <> "" THEN
                      EQU$(EQUCnt) = UCASE$(equname$) + " " + equvalue$
                      EQUCnt = EQUCnt + 1
                   END IF
               END IF
            END IF

            IF skipme = 0 THEN  'kolla hr om ngon definierad EQU finns i raden  erstt
               FOR kaka = 1 TO CheckEQUTimes
                   text$ = CheckEQU(text$)
               NEXT kaka
               text$ = CalcEQU(text$)
               IF LEFT$(text$, 1) <> "." THEN LabelPosCounter = LabelPosCounter + 1
               PRINT #2, tmp1$ + " " + text$
            END IF

         END IF
      END IF
   LOOP
   CLOSE #1, #2

IF OrgAdr& = 0 THEN OrgAdr& = &H80200000

IF ByteSwap = -1 THEN
   rad$ = ByteRad$
   ErrorCode 7, tempo$
END IF

IF ByteSwap = 0 THEN OutFile$ = OutFile$ + ".BIN"
IF ByteSwap = 1 THEN OutFile$ = OutFile$ + ".V64"



'
PRINT ErrorSpaces$; " Reading and parsing is done, generating binary .."
ErrorSpaces$ = "    "
'
GenerateBinary

'
'lgger till 1 till 3 nollor p slutet fr att filstorleken
'ska kunna delas jmt med 2,4 eller 8.

ErrFile$ = TempFile2$
OPEN ErrFile$ FOR BINARY AS #2
   OutLen# = LOF(2)
CLOSE #2

tmp1# = OutLen# / AlignSize  ' 2,4 eller 8
tmp2# = INT(tmp1# + .5)
NewOutLen# = OutLen#

IF tmp1# <> tmp2# THEN
   'mste lgga till nollor
   DO
     NewOutLen# = NewOutLen# + 1
     tmp1# = NewOutLen# / AlignSize  '2,4 eller 8
     tmp2# = INT(tmp1# + .5)
     IF tmp1# = tmp2# THEN
        EXIT DO
     END IF
   LOOP
   AddOutLen# = NewOutLen# - OutLen#
   addcode$ = STRING$(AddOutLen#, CHR$(0))
   ErrFile$ = TempFile2$
   OPEN ErrFile$ FOR BINARY AS #2
      PUT #2, MainCode&, addcode$
   CLOSE #2
END IF





'
ErrFile$ = TempFile2$
OPEN ErrFile$ FOR BINARY AS #2
   OutLen# = LOF(2)
CLOSE #2
PRINT ErrorSpaces$; " Generated ";

GreatBytes$ = LTRIM$(STR$(OutLen#))
PRINT OutFile$; " ("; GreatBytes$; " bytes)"
'","; LabelPosCounter; "opcode(s)"


'
'byteswap image
ErrorSpaces$ = "       "
'
IF ByteSwap = 1 THEN
   PRINT ErrorSpaces$; " Byteswapping .. ";
   ErrFile$ = TempFile2$
   OPEN ErrFile$ FOR BINARY AS #2   'orginalfil
   ErrFile$ = OutFile$
   OPEN ErrFile$ FOR BINARY AS #3
       dword$ = "    "
       DO
          GET #2, , dword$
          IF EOF(2) THEN EXIT DO
          vmput$ = ""
          FOR ttx = 1 TO 4 STEP 2
              vmp1$ = MID$(dword$, ttx, 1)
              vmp2$ = MID$(dword$, ttx + 1, 1)
              vmput$ = vmput$ + vmp2$ + vmp1$
          NEXT
          PUT #3, , vmput$
       LOOP
   CLOSE #2, #3

   IF DebugMode = 0 THEN KILL TempFile2$

   PRINT "Done."
END IF

'
'Fix megabit size, adda 00h till korrekt storlek
'
    MBitSize& = MBitVal
    IF MBitSize& > 0 THEN
       bytesize# = ((MBitSize& * 1024) * 1024) / 8
       PRINT ErrorSpaces$; " Fixing file lenght to"; bytesize#; "bytes ("; LTRIM$(STR$(MBitVal)); " MBit) .. ";
       ErrFile$ = OutFile$
       OPEN ErrFile$ FOR BINARY AS #2
       RestCode& = MainCode&
       DO
          towrite# = bytesize# - RestCode&
          IF towrite# > 7000 THEN
             tmp$ = STRING$(7000, CHR$(0))
             PUT #2, RestCode&, tmp$
             RestCode& = RestCode& + 7000
          ELSE
             tmp$ = STRING$(towrite# + 1, CHR$(0))
             PUT #2, RestCode&, tmp$
             endvillkor = 1
          END IF
       LOOP UNTIL endvillkor = 1
       CLOSE #2
       PRINT "Done."
    END IF
'


IF NonExistLabelCnt + UnknownInstr > 0 THEN 'visar om det blev ntt fel
   PRINT ErrorSpaces$; " Found"; NonExistLabelCnt; "non-existing label(s) and"; UnknownInstr; "unknown instruction(s)"
END IF

IF UnSuppCnt > 0 THEN PRINT " Found"; UnSuppCnt; "unsupported opcode(s)"

IF BadFlag = 1 THEN
   IF KeepFile = 0 THEN
      PRINT ErrorSpaces$; " Binary has errors, deleting it."
      IF DebugMode = 0 THEN KILL TempFile2$
   END IF
END IF

PRINT ErrorSpaces$; " There occured"; ErrCnt; "error(s)"

IF DebugMode = 0 THEN KILL TempFile$

END







ErrorMessage:
    PRINT ErrorSpaces$; " DOS error "; LTRIM$(STR$(ERR)); ": ";
    SELECT CASE ERR
        CASE 6: PRINT "Overflow."
        CASE 14: PRINT "Out of string space."
        CASE 64: PRINT ErrFile$; " is a bad filename."
        CASE 70: PRINT ErrFile$; " is used by another program."
        CASE 75: PRINT ErrFile$; " cannot be deleted (path/file access error)."
        CASE ELSE: PRINT "Unknown error."
    END SELECT
CLOSE

END

SUB ByteBlock

    known = 1
    ByteText$ = GetByteValue(param$)
    ByteTxtLen = LEN(ByteText$)
                    
    PUT #2, MainCode&, ByteText$: MainCode& = MainCode& + ByteTxtLen

END SUB

FUNCTION CalcEQU$ (xxx$)
   
    'kollar om det r en EQU med en kalkulation, och rknar ut den:
    IF UCASE$(LEFT$(xxx$, 4)) = "EQU " THEN
       xx2$ = LTRIM$(MID$(xxx$, 4))
       temp$ = GetValue32(xx2$)
       IF temp$ <> "" THEN
          CalcEQU = "EQU " + temp$
       ELSE
          CalcEQU = xxx$
       END IF
    ELSE
       CalcEQU = xxx$
    END IF

END FUNCTION

FUNCTION CheckEQU$ (tsxx$)

    tsxx2$ = tsxx$
    FOR a = 0 TO EQUCnt - 1
        kmp1 = INSTR(EQU$(a), " ")
        kmpname$ = LEFT$(EQU$(a), kmp1 - 1)
        kmpvalue$ = MID$(EQU$(a), kmp1 + 1)
        kmp2 = INSTR(UCASE$(tsxx$), kmpname$)
        IF kmp2 > 0 THEN  'hittade en rad med EQU grejs i
           'kolla tecknet innan och efter EQU'n fr att frskra oss
           'om att det r en kta equ och inte en del av en annan
           'strng eller ngot i den stilen.
           IF kmp2 > 1 THEN
              DelInnan2$ = UCASE$(MID$(tsxx$, kmp2 - 1, 1))
              DelInnan = ASC(DelInnan2$)
           ELSE
              DelInnan = 0
           END IF
          
           DelEfter2$ = UCASE$(MID$(tsxx$, kmp2 + LEN(kmpname$), 1))
           IF DelEfter2$ <> "" THEN
              DelEfter = ASC(DelEfter2$)
           ELSE
              DelEfter = 0
           END IF
          
           ItIsWrong1 = 0 'fr vara vadsomhelst utan siffra och boxtav
           IF DelInnan > 47 AND DelInnan < 58 THEN ItIsWrong1 = 1  '0-9
           IF DelInnan > 64 AND DelInnan < 91 THEN ItIsWrong1 = 1  'A-Z
           IF DelInnan > 96 AND DelInnan < 123 THEN ItIsWrong1 = 1 'a-z

           ItIsWrong2 = 0
           IF DelEfter > 47 AND DelInnan < 58 THEN ItIsWrong2 = 1  '0-9
           IF DelEfter > 64 AND DelInnan < 91 THEN ItIsWrong2 = 1  'A-Z
           IF DelEfter > 96 AND DelInnan < 123 THEN ItIsWrong2 = 1 'a-z
           
           IF ItIsWrong1 + ItIsWrong2 = 0 THEN  'om det inte e fel
              kmplen = LEN(kmpname$)
              tsxx2$ = LEFT$(tsxx$, kmp2 - 1) + kmpvalue$ + MID$(tsxx$, kmp2 + kmplen)
              tsxx$ = tsxx2$
           END IF

        END IF
    NEXT a

    CheckEQU = tsxx$
   
END FUNCTION

FUNCTION CountStr (txx$, sort$)

   fvnt = 0
   FOR vra = 1 TO LEN(txx$)
      klet$ = MID$(txx$, vra, 1)
      IF klet$ = sort$ THEN fvnt = fvnt + 1
   NEXT vra
   CountStr = fvnt

END FUNCTION

SUB ErrorCode (num, txt$)
   
    BadFlag = 1
    ErrCnt = ErrCnt + 1
    IF ErrCnt > MaxErrors THEN
       CLOSE #1, #2
       IF DebugMode = 0 THEN KILL TempFile2$
       IF DebugMode = 0 THEN KILL TempFile$
       PRINT ErrorSpaces$; " Over"; MaxErrors; "errors occured, aborted assembling."
       END
    END IF

    ErrorFile$ = InFile$
    ErrorRad$ = rad$
    stkmp = INSTR(ErrorRad$, "_")
    IF stkmp THEN   'identifierar att det e en INCLUDE fil
       ErrorFile$ = MID$(ErrorRad$, stkmp + 1)
       ErrorRad$ = LEFT$(ErrorRad$, stkmp - 1)
    END IF

    ErrorFile$ = LCASE$(ErrorFile$)    'sm boxtver mkt snyggare
    
    
    IF ErrorRad$ = "" THEN
       PRINT ErrorSpaces$; " error"; STR$(num); ": ";
    ELSE
       PRINT ErrorSpaces$; " "; ErrorFile$; "("; ErrorRad$; ") error"; STR$(num); ": ";
    END IF
    SELECT CASE num
       CASE 1:  PRINT "Unknown register '"; txt$; "'"
       CASE 2:  PRINT "Unknown instruction '"; txt$; "'"
       CASE 3:  PRINT "Non-existing label '"; txt$; "'": NonExistLabelCnt = NonExistLabelCnt + 1
       CASE 4:  PRINT "Unsupported opcode '"; inst$; "'": UnSuppCnt = UnSuppCnt + 1
       CASE 5:  PRINT inst$; ": Too many parameters ("; txt$; ")"
       CASE 6:  PRINT inst$; ": Too few parameters ("; txt$; ")"
       CASE 7:  PRINT "Invalid parameter '"; txt$; "'"
       CASE 8:  PRINT "Unknown variable '"; txt$; "'"
       CASE 9:  PRINT "Overflow ("; txt$; " is too big)"
       CASE 10: PRINT "Includefile "; txt$; " does not exist."
       CASE 11: PRINT "Too complex calculation '"; txt$; "'"
       CASE 12: PRINT "OPT directives support not implemented '"; param$; "'"
       CASE 13: PRINT "Direct values isn't supported yet."
       CASE 14: PRINT "Align size "; txt$; " is wrong, only 2,4 and 8 are valid."
       CASE ELSE: PRINT "Unknown error."
    END SELECT

END SUB

DEFSNG A-Z
FUNCTION FixVal16$ (flump$)
         
     knas$ = GetValue16(flump$)
     knas$ = HEX$(VAL(knas$))
    
     knorr& = VAL("&h" + knas$)
    
     knas$ = "0000" + knas$
     knas$ = RIGHT$(knas$, 4)
     FOR a = 1 TO LEN(knas$) STEP 2
         del = VAL("&h" + MID$(knas$, a, 2))
         temp$ = temp$ + CHR$(del)
     NEXT a
     FixVal16$ = temp$

END FUNCTION

DEFINT A-Z
FUNCTION FromBin (txt$)
  
   dum = 1: svar = 0
   FOR cca = LEN(txt$) TO 1 STEP -1
       tmp$ = MID$(txt$, cca, 1)
       IF tmp$ = "1" THEN svar = svar + dum
       dum = dum * 2
   NEXT
   FromBin = svar

END FUNCTION

FUNCTION FromBin32& (txt$)
  
   dum# = 1: svar& = 0
   FOR cca = LEN(txt$) TO 1 STEP -1
       tmp$ = MID$(txt$, cca, 1)
       IF tmp$ = "1" THEN svar& = svar& + dum#
       dum# = dum# * 2
   NEXT
   FromBin32& = svar&

END FUNCTION

SUB GenerateBinary
   
    IF ByteSwap = 0 THEN TempFile2$ = OutFile$
    ErrFile$ = TempFile2$
    OPEN ErrFile$ FOR BINARY AS #2: CLOSE #2
    IF DebugMode = 0 THEN KILL TempFile2$
  
    ErrFile$ = TempFile$
    OPEN ErrFile$ FOR INPUT AS #1
    ErrFile$ = TempFile2$
    OPEN ErrFile$ FOR BINARY AS #2
         IF NoHeader = 0 THEN
            temp$ = CHR$(&H80) + CHR$(&H37) + CHR$(&H12) + CHR$(&H40)
            temp$ = temp$ + CHR$(0) + CHR$(0) + CHR$(0) + CHR$(&HF)
            temp$ = temp$ + CHR$(&H80) + CHR$(&H20) + CHR$(0) + CHR$(0)
            temp$ = temp$ + CHR$(0) + CHR$(0) + CHR$(&H14) + STRING$(&HFF1, 0)
            PUT #2, &H1, temp$
            MainCode& = &H1001
            IF OrgAdrValue$ <> "" THEN PUT #2, &H9, OrgAdrValue$
          
            IF BootTitle$ <> "" THEN PUT #2, &H20 + 1, BootTitle$
            IF BootManufact$ <> "" THEN PUT #2, &H3B + 1, BootManufact$
            IF BootCartID$ <> "" THEN PUT #2, &H3C + 1, BootCartID$
            IF BootCountry$ <> "" THEN PUT #2, &H3E + 1, BootCountry$
            IF BootCode$ <> "" THEN
               PRINT ErrorSpaces$; " Using boot code in "; UCASE$(BootCode$)
               ErrFile$ = BootCode$
               OPEN ErrFile$ FOR BINARY AS #4
               nytmp = LOF(4)
               IF nytmp = 0 THEN
                  PRINT " ("; rad$; ") File "; param$; " is missing."
                  CLOSE #4
                  IF DebugMode = 0 THEN KILL temp$
               ELSE
                 IF nytmp <> 4032 THEN
                    PRINT " ("; rad$; ") File "; param$; " is not a valid ROM header."
                 ELSE
                    fintemp$ = STRING$(4032, 0)
                    GET #4, 1, fintemp$: PUT #2, &H41, fintemp$
                 END IF
                 CLOSE #4
              END IF
            END IF
         ELSE
            MainCode& = &H1
         END IF


         DO
            known = 0
            OpcodePosCnt = OpcodePosCnt + 1
            IF EOF(1) THEN EXIT DO
            LINE INPUT #1, text$
            tmp = INSTR(text$, " ")
            code$ = LTRIM$(MID$(text$, tmp + 1)) + " "
            rad$ = LEFT$(text$, tmp - 1)                  'rad-nummer
            tmp = INSTR(code$, " ")
            inst$ = LTRIM$(UCASE$(LEFT$(code$, tmp - 1))) 'instruktion
            param$ = LTRIM$(RTRIM$(MID$(code$, tmp + 1)))         'parametrar
          
          
               'opcode
               SELECT CASE inst$
                  CASE "ADDI":   Type1 "001000"
                  CASE "ADDIU":  Type1 "001001"
                  CASE "SLTI":   Type1 "001010"
                  CASE "SLTIU":  Type1 "001011"
                  CASE "ANDI":   Type1 "001100"
                  CASE "ORI":    Type1 "001101"
                  CASE "XORI":   Type1 "001110"
                  CASE "DADDI":  Type1 "011000"
                  CASE "DADDIU": Type1 "011001"
                  CASE "LDL":    Type1 "011010"
                  CASE "LDR":    Type1 "011011"
                  CASE "LB":     Type1 "100000"
                  CASE "LH":     Type1 "100001"
                  CASE "LWL":    Type1 "100010"
                  CASE "LW":     Type1 "100011"
                  CASE "LBU":    Type1 "100100"
                  CASE "LHU":    Type1 "100101"
                  CASE "LWR":    Type1 "100110"
                  CASE "LWU":    Type1 "100111"
                  CASE "SB":     Type1 "101000"
                  CASE "SH":     Type1 "101001"
                  CASE "SWL":    Type1 "101010"
                  CASE "SW":     Type1 "101011"
                  CASE "SDL":    Type1 "101100"
                  CASE "SDR":    Type1 "101101"
                  CASE "SWR":    Type1 "101110"
                  CASE "CACHE":  Type1 "101111"
                  CASE "LL":     Type1 "110000"
                  CASE "PREF":   Type1 "110011"
                  CASE "LLD":    Type1 "110100"
                  CASE "LD":     Type1 "110111"
                  CASE "SC":     Type1 "111000"
                  CASE "SCD":    Type1 "111100"
                  CASE "SD":     Type1 "111111"
                  CASE "LUI":    Type2 "001111"
                
                  'CASE "J":      Type8 "000010"
                  'CASE "JAL":    Type8 "000011"
                  CASE "J":   known = 1
                  CASE "JAL": known = 1

                  CASE "BEQ":    Type10 "000100"
                  CASE "BNE":    Type10 "000101"
                  CASE "BLEZ":   Type11 "000110"
                  CASE "BGTZ":   Type11 "000111"
                  CASE "BEQL":   Type10 "010100"
                  CASE "BNEL":   Type10 "010101"
                  CASE "BLEZL":  Type11 "010110"
                  CASE "BGTZL":  Type11 "010111"

                  'special
                  CASE "SLLV":   Type3 "000100"
                  CASE "SRLV":   Type3 "000110"
                  CASE "SRAV":   Type3 "000111"
                  CASE "DSLLV":  Type3 "010100"
                  CASE "ADD":    Type3 "100000"
                  CASE "ADDU":   Type3 "100001"
                  CASE "SUB":    Type3 "100010"
                  CASE "SUBU":   Type3 "100011"
                  CASE "AND":    Type3 "100100"
                  CASE "OR":     Type3 "100101"
                  CASE "XOR":    Type3 "100110"
                  CASE "NOR":    Type3 "100111"
                  CASE "SLT":    Type3 "101010"
                  CASE "SLTU":   Type3 "101011"
                  CASE "DADD":   Type3 "101100"
                  CASE "DADDU":  Type3 "101101"
                  CASE "DSUB":   Type3 "101110"
                  CASE "DSUBU":  Type3 "101111"
                
                  CASE "SLL":    Type4 "000000"
                  CASE "SRL":    Type4 "000010"
                  CASE "SRA":    Type4 "000011"
                  CASE "DSRLV":  Type4 "010110"
                  CASE "DSRAV":  Type4 "010111"
                  CASE "DSLL":   Type4 "111000"
                  CASE "DSRL":   Type4 "111010"
                  CASE "DSRA":   Type4 "111011"
                  CASE "DSLL32": Type4 "111100"
                  CASE "DSRL32": Type4 "111110"
                  CASE "DSRA32": Type4 "111111"

                  CASE "MULT":   Type5 "011000"
                  CASE "MULTU":  Type5 "011001"
                  CASE "DIV":    Type5 "011010"
                  CASE "DIVU":   Type5 "011011"
                  CASE "DMULT":  Type5 "011100"
                  CASE "DMULTU": Type5 "011101"
                  CASE "DDIV":   Type5 "011110"
                  CASE "DDIVU":  Type5 "011111"
                  CASE "MFHI":   Type6 "010000"
                  CASE "MFLO":   Type6 "010010"
                  CASE "JR":     Type7 "001000"
                  CASE "MTHI":   Type7 "010001"
                  CASE "MTLO":   Type7 "010011"
                  CASE "SYNC":   Type18 "001111"
                  CASE "JALR":   Type19 "001001"

                  'regimm
                  CASE "BLTZ":    Type9 "00000"
                  CASE "BGEZ":    Type9 "00001"
                  CASE "BLTZL":   Type9 "00010"
                  CASE "BGEZL":   Type9 "00011"
                  CASE "BLTZAL":  Type9 "10000"
                  CASE "BGEZAL":  Type9 "10001"
                  CASE "BLTZALL": Type9 "10010"
                  CASE "BGEZALL": Type9 "10011"

                  CASE "TGEI":   Type31 "01000"
                  CASE "TGEIU":  Type31 "01001"
                  CASE "TLTI":   Type31 "01010"
                  CASE "TLTIU":  Type31 "01011"
                  CASE "TEQI":   Type31 "01100"
                  CASE "TNEI":   Type31 "01110"

                 
                  CASE "TEQ":    Type29 "110100"
                  CASE "TGE":    Type29 "110000"
                  CASE "TGEU":   Type29 "110001"
                  CASE "TLT":    Type29 "110010"
                  CASE "TLTU":   Type29 "110011"
                  CASE "TNE":    Type29 "110110"

                  CASE "BREAK":   Type30 "001101"
                  CASE "SYSCALL": Type30 "001100"
                 
           
                  'cop0
                  CASE "MFC0":   Type12 "00000"
                  CASE "DMFC0":  Type12 "00001"
                  CASE "CFC0":   Type12 "00010"
                  CASE "MTC0":   Type12 "00100"
                  CASE "DMTC0":  Type12 "00101"
                  CASE "CTC0":   Type12 "00110"
                  CASE "ERET":   Type13 "011000"
                  CASE "TLBP":   Type13 "001000"
                  CASE "TLBR":   Type13 "000001"
                  CASE "TLBWI":  Type13 "000010"
                  CASE "TLBWR":  Type13 "000110"
                  CASE "BC0F":   Type16 "00"
                  CASE "BC0FL":  Type16 "10"
                  CASE "BC0T":   Type16 "01"
                  CASE "BC0TL":  Type16 "11"
         
                  'cop1
                  CASE "MFC1":   Type14 "00000"
                  CASE "DMFC1":  Type14 "00001"
                  CASE "CFC1":   Type14 "00010"
                  CASE "MTC1":   Type14 "00100"
                  CASE "DMTC1":  Type14 "00101"
                  CASE "CTC1":   Type14 "00110"
                  CASE "BC1F":   Type17 "00"
                  CASE "BC1FL":  Type17 "10"
                  CASE "BC1T":   Type17 "01"
                  CASE "BC1TL":  Type17 "11"
                  CASE "LWC1":   Type32 "110001"
                  CASE "LDC1":   Type32 "110101"
                  CASE "SDC1":   Type32 "111101"
                  CASE "SWC1":   Type32 "111001"
                  CASE "ADD.S":  Type20 "000000"
                  CASE "SUB.S":  Type20 "000001"
                  CASE "MUL.S":  Type20 "000010"
                  CASE "DIV.S":  Type20 "000011"
                  CASE "ADD.D":  Type21 "000000"
                  CASE "SUB.D":  Type21 "000001"
                  CASE "MUL.D":  Type21 "000010"
                  CASE "DIV.D":  Type21 "000011"
                  CASE "ABS.S":     Type22 "000101"
                  CASE "CEIL.L.S":  Type22 "001010"
                  CASE "CEIL.W.S":  Type22 "001110"
                  CASE "CVT.D.S":   Type22 "100001"
                  CASE "CVT.L.S":   Type22 "100101"
                  CASE "CVT.W.S":   Type22 "100100"
                  CASE "FLOOR.L.S": Type22 "001011"
                  CASE "FLOOR.W.S": Type22 "001111"
                  CASE "MOV.S":     Type22 "000110"
                  CASE "NEG.S":     Type22 "000111"
                  CASE "ROUND.L.S": Type22 "001000"
                  CASE "ROUND.W.S": Type22 "001100"
                  CASE "SQRT.S":    Type22 "000100"
                  CASE "TRUNC.L.S": Type22 "001001"
                  CASE "TRUNC.W.S": Type22 "001101"
                  CASE "ABS.D":     Type23 "000101"
                  CASE "CEIL.L.D":  Type23 "001010"
                  CASE "CEIL.W.D":  Type23 "001110"
                  CASE "CVT.S.D":   Type23 "100000"
                  CASE "CVT.L.D":   Type23 "100101"
                  CASE "CVT.W.D":   Type23 "100100"
                  CASE "FLOOR.L.D": Type23 "001011"
                  CASE "FLOOR.W.D": Type23 "001111"
                  CASE "MOV.D":     Type23 "000110"
                  CASE "NEG.D":     Type23 "000111"
                  CASE "ROUND.L.D": Type23 "001000"
                  CASE "ROUND.W.D": Type23 "001100"
                  CASE "SQRT.D":    Type23 "000100"
                  CASE "TRUNC.L.D": Type23 "001001"
                  CASE "TRUNC.W.D": Type23 "001101"
                  CASE "CVT.S.W":   Type24 "100000"
                  CASE "CVT.D.W":   Type24 "100001"
                  CASE "CVT.S.L":   Type25 "100000"
                  CASE "CVT.D.L":   Type25 "100001"
             
                  'compares
                  CASE "C.F.S":     Type27 "0000"
                  CASE "C.UN.S":    Type27 "0001"
                  CASE "C.EQ.S":    Type27 "0010"
                  CASE "C.UEQ.S":   Type27 "0011"
                  CASE "C.OLT.S":   Type27 "0100"
                  CASE "C.ULT.S":   Type27 "0101"
                  CASE "C.OLE.S":   Type27 "0110"
                  CASE "C.ULE.S":   Type27 "0111"
                  CASE "C.SF.S":    Type27 "1000"
                  CASE "C.NGLE.S":  Type27 "1001"
                  CASE "C.SEQ.S":   Type27 "1010"
                  CASE "C.NGL.S":   Type27 "1011"
                  CASE "C.LT.S":    Type27 "1100"
                  CASE "C.NGE.S":   Type27 "1101"
                  CASE "C.LE.S":    Type27 "1110"
                  CASE "C.NGT.S":   Type27 "1111"
                
                  CASE "C.F.D":     Type28 "0000"
                  CASE "C.UN.D":    Type28 "0001"
                  CASE "C.EQ.D":    Type28 "0010"
                  CASE "C.UEQ.D":   Type28 "0011"
                  CASE "C.OLT.D":   Type28 "0100"
                  CASE "C.ULT.D":   Type28 "0101"
                  CASE "C.OLE.D":   Type28 "0110"
                  CASE "C.ULE.D":   Type28 "0111"
                  CASE "C.SF.D":    Type28 "1000"
                  CASE "C.NGLE.D":  Type28 "1001"
                  CASE "C.SEQ.D":   Type28 "1010"
                  CASE "C.NGL.D":   Type28 "1011"
                  CASE "C.LT.D":    Type28 "1100"
                  CASE "C.NGE.D":   Type28 "1101"
                  CASE "C.LE.D":    Type28 "1110"
                  CASE "C.NGT.D":   Type28 "1111"


                  'cop2
                  CASE "DMFC2":  Type15 "00001"
                  CASE "CFC2":   Type15 "00010"
                  CASE "DMTC2":  Type15 "00101"
                  CASE "CTC2":   Type15 "00110"
                  CASE "MFC2":   Type15 "00000"
                  CASE "MTC2":   Type15 "00100"
                  CASE "LWC2":   Type1 "110010"
                  CASE "LDC2":   Type1 "110110"
                  CASE "SDC2":   Type1 "111110"
                  CASE "SWC2":   Type1 "111010"
                
                  'spektakulra ... :-)
                  CASE "BC2F":   Type26 "00"
                  CASE "BC2FL":  Type26 "10"
                  CASE "BC2T":   Type26 "01"
                  CASE "BC2TL":  Type26 "11"

                  'special stuff
                  CASE "DB", ".BYTE":         ByteBlock       'Define Byte
                  CASE "DH", ".HWORD":        HalfBlock       'Define Halfword
                  CASE "DW", "DD", ".WORD":   WordBlock       'Define Doubleword
                 
                
                  CASE ".DCB", "DCB", ".BLOCK": InsertBlock   'mosar in massa kod
                  CASE "INCBIN", ".FILE":       IncludeBin    'PSY-Q compatiblity (.FILE = asm64)

                  CASE "OPT":    HandleDirective 'PSY-Q compatiblity

                  'pseudo opcodes
                  CASE "NOP":    Type0
                  CASE "MOVE":   PseudoType1 "100000"
                  CASE "BNEZ":   PseudoType2 "000101"
                  CASE "BEQZ":   PseudoType2 "000100"
                  CASE "BNEZL":  PseudoType2 "010101"
                  CASE "BEQZL":  PseudoType2 "010100"
                  CASE "NEGU":   PseudoType3 "100011"
                  CASE "NEG":    PseudoType3 "100010"
                  CASE "B":      PseudoType4 "000100"
                  CASE "BAL":    PseudoType5 "100001"
                  CASE "LI":     PseudoType6 "001101"
                  CASE "S.S":    Type32 "111001"
                  CASE "L.S":    Type32 "110001"

                  CASE "C2":
                    IF DebugMode = 1 THEN known = 1

               END SELECT
            
               IF known = 0 THEN
                  ErrorCode 2, inst$
                  UnknownInstr = UnknownInstr + 1
               
                  'lgger dit dword "BAD!" fr att filen ska bli lika stor nd
                  opcode$ = "BAD!"
                  PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
               END IF
           
         LOOP WHILE NOT EOF(1)
    CLOSE #1, #2

END SUB

FUNCTION GetAdr& (tmp$)

   'tar reda p addressen fr en label

   'kollar om tmp$ r en label eller ett direkt vrde:
   ttx = ASC(LEFT$(tmp$, 1))
   ItIsALabel = 0
   IF ttx > 64 AND ttx < 91 THEN ItIsALabel = 1
   IF ttx > 96 AND ttx < 123 THEN ItIsALabel = 1
   IF ttx = ASC("_") THEN ItIsALabel = 1


   IF ItIsALabel = 1 THEN
      flum = LEN(tmp$): hittad& = -1
  
      FOR a& = 0 TO LabelCnt&
          IF LCASE$(LEFT$(Label$(a&), flum + 1)) = LCASE$(tmp$) + ":" THEN
             hittad& = VAL(MID$(Label$(a&), flum + 2))
          END IF
      NEXT
      IF hittad& = -1 THEN
         ErrorCode 3, tmp$
      ELSE
         GetAdr& = hittad&
      END IF
   ELSE
      'direkt vrde:
      ''ErrorCode 13, ""
      ttaxx$ = GetValue32(tmp$)
      GetAdr& = VAL(ttaxx$)
   END IF

END FUNCTION

FUNCTION GetBranchVal$ (num&)
       
       flurp& = (num& * 4) - OpcodePosCnt
       IF flurp& < 0 THEN
          blur$ = "11"
          blur2$ = "FFFF"
       ELSE
          blur$ = "00"
          blur2$ = "0000"
       END IF
       bra$ = blur2$ + HEX$(flurp&)
       bra$ = RIGHT$(bra$, 4)

       bra1$ = MID$(bra$, 1, 2)
       bra2$ = MID$(bra$, 3, 2)

       GetBranchVal = CHR$(VAL("&h" + bra1$)) + CHR$(VAL("&h" + bra2$))

END FUNCTION

FUNCTION GetBranchValBREAK$ (num&)
     
       flurp& = (num& * 4) - OpcodePosCnt
       IF flurp& < 0 THEN
          blur$ = "11"
          blur2$ = "FFFF"
       ELSE
          blur$ = "00"
          blur2$ = "0000"
       END IF
       bra$ = blur2$ + HEX$(flurp&)
       bra$ = RIGHT$(bra$, 4)
       tmp1& = VAL("&h" + bra$)
       
       tmp2$ = ToBin32(tmp1&)

       GetBranchValBREAK = RIGHT$(tmp2$, 20)

END FUNCTION

FUNCTION GetByteValue$ (txt$)
   
    sep1$ = CHR$(34)
    intext = 0

    FOR a = 1 TO LEN(txt$)
        funnen = 0
        kool$ = MID$(txt$, a, 1)
        IF kool$ = sep1$ THEN
           funnen = 1
           IF intext = 0 THEN
              intext = 1
           ELSE
              intext = 0
           END IF
        END IF
        IF funnen = 0 THEN
           IF intext = 1 THEN
              OutStr$ = OutStr$ + kool$
           ELSE
              IF kool$ = "," THEN
                 tmp$ = LTRIM$(MID$(txt$, a + 1))
                
                 IF LEFT$(tmp$, 1) <> sep1$ THEN
                    jaho = INSTR(tmp$, ",")
                    IF jaho = 0 THEN    'sista delen i raden
                       OutStr$ = OutStr$ + CHR$(VAL(tmp$))
                    ELSE
                       tmp2$ = LEFT$(tmp$, jaho - 1)
                       tmp3 = VAL(tmp2$)
                       OutStr$ = OutStr$ + CHR$(tmp3)
                       a = a + LEN(tmp2$) - 1
                    END IF
                 END IF
              ELSE
                 OutStr$ = OutStr$ + kool$
              END IF
           END IF
        END IF

    NEXT a
   
    GetByteValue$ = OutStr$


END FUNCTION

FUNCTION GetDec& (txx$)
    'omvandlar frn hex-textstrng till decimalt

    IF LCASE$(RIGHT$(txx$, 1)) = "h" THEN    'hex tal
       tmp1 = LEN(txx$): vxx$ = LEFT$(txx$, tmp1 - 1) 'tar bort h'et p slutet
       tmp1 = LEN(txx$)

       GetDec& = VAL("&h" + vxx$)
       foundit = 1
    END IF
    IF LCASE$(LEFT$(txx$, 2)) = "0x" THEN     'hex tal, C++ variant
       vxx$ = MID$(txx$, 3)                   'tar bort 0x i brjan
       tmp1 = LEN(vxx$)

       GetDec& = VAL("&h" + vxx$)
       foundit = 1
    END IF

    IF foundit = 0 THEN     ' vanligt decimalt tal
       GetDec& = VAL(txx$)
    END IF

END FUNCTION

SUB GetSyntax
  
   Syntax$ = UCASE$(Syntax$) + " "

   temp = INSTR(Syntax$, "-BYTESWAP ")
   IF temp THEN
      ByteSwap = 1  ' byteswapping ON
      Syntax$ = LEFT$(Syntax$, temp - 1) + MID$(Syntax$, temp + 10)
   END IF

   temp = INSTR(Syntax$, "-KEEPFILE ")
   IF temp THEN
      KeepFile = 1  ' keep file if error occurs
      Syntax$ = LEFT$(Syntax$, temp - 1) + MID$(Syntax$, temp + 10)
   END IF

   temp = INSTR(Syntax$, "-EQU")
   IF temp THEN
      tempB$ = MID$(Syntax$, temp)
      temp2 = INSTR(tempB$, " ")
      tempC$ = LEFT$(tempB$, temp2 - 1)
      tempD$ = MID$(tempC$, 5)
      IF tempD$ <> "" THEN
         CheckEQUTimes = VAL(tempD$)
      END IF
      Syntax$ = LEFT$(Syntax$, temp - 1) + MID$(Syntax$, temp + LEN(tempC$))
   END IF

   temp = INSTR(Syntax$, "-ERR")
   IF temp THEN
      tempB$ = MID$(Syntax$, temp)
      temp2 = INSTR(tempB$, " ")
      tempC$ = LEFT$(tempB$, temp2 - 1)
      tempD$ = MID$(tempC$, 5)
      IF tempD$ <> "" THEN
         MaxErrors = VAL(tempD$)
      END IF
      Syntax$ = LEFT$(Syntax$, temp - 1) + MID$(Syntax$, temp + LEN(tempC$))
   END IF

   temp = INSTR(Syntax$, "-HEADER ")
   IF temp THEN
      NoHeader = 0   'generates header
      Syntax$ = LEFT$(Syntax$, temp - 1) + MID$(Syntax$, temp + 8)
   END IF

   temp = INSTR(Syntax$, "-ALIGN")
   IF temp THEN
      tempB$ = MID$(Syntax$, temp)
      temp2 = INSTR(tempB$, " ")
      tempC$ = LEFT$(tempB$, temp2 - 1)
      tempD$ = MID$(tempC$, 7)
      IF tempD$ <> "" THEN
         AlignTmp = VAL(tempD$)
      END IF
      SELECT CASE AlignTmp
          CASE 2, 4, 8: AlignSize = AlignTmp
          CASE ELSE: ErrorCode 14, tempD$
      END SELECT
      Syntax$ = LEFT$(Syntax$, temp - 1) + MID$(Syntax$, temp + LEN(tempC$))
   END IF






   Syntax$ = LTRIM$(RTRIM$(Syntax$))
   IF Syntax$ <> "" THEN
      ttmp = INSTR(Syntax$, " -")
      IF ttmp THEN ShowSyntax LTRIM$(MID$(Syntax$, ttmp))
      IF LEFT$(Syntax$, 1) = "-" THEN
         ttmp = INSTR(Syntax$, " ")
         ShowSyntax LTRIM$(MID$(Syntax$, 1, ttmp - 1))
      END IF
      InFile$ = Syntax$
   ELSE
      ShowSyntax ""
   END IF


   temp = INSTR(InFile$, ".")
   IF temp = 0 THEN
      OutFile$ = InFile$
   ELSE
      OutFile$ = LEFT$(InFile$, temp - 1)
      DO
        temp = INSTR(TempFile2$, "\")
        IF temp > 0 THEN
           OutFile$ = MID$(TempFile2$, temp + 1)
        ELSE
           slutvillkor = 1
        END IF
      LOOP WHILE slutvillkor = 0
   END IF


END SUB

FUNCTION GetTrueVal16& (flump$)

    'omvandlar frn hex-textstrng till decimalt
    'eller textstrng, eller snt :)
    flump$ = LTRIM$(RTRIM$(flump$))
    IF LCASE$(RIGHT$(flump$, 1)) = "h" THEN    'hex tal
       tmp1 = LEN(flump$): flump$ = LEFT$(flump$, tmp1 - 1)  'tar bort h'et p slutet
       foundit = 1
       knorr& = VAL("&h" + flump$)
       IF knorr& < 65536 THEN      'overflow checking
          GetTrueVal16 = knorr&
       ELSE
          ErrorCode 9, HEX$(knorr&)
       END IF
    END IF
    IF LCASE$(LEFT$(flump$, 1)) = "$" THEN    'hex tal
       tmp1 = LEN(flump$): flump$ = RIGHT$(flump$, tmp1 - 1)  'tar bort $
       foundit = 1
       knorr& = VAL("&h" + flump$)
       IF knorr& < 65536 THEN      'overflow checking
          GetTrueVal16 = knorr&
       ELSE
          ErrorCode 9, HEX$(knorr&)
       END IF
    END IF

    IF LCASE$(LEFT$(flump$, 2)) = "0x" THEN     'hex tal, C++ variant
       IF foundit = 0 THEN
          flump$ = MID$(flump$, 3)                   'tar bort 0x i brjan
          foundit = 1
          knorr& = VAL("&h" + flump$)
          IF knorr& < 65536 THEN      'overflow checking
             GetTrueVal16 = knorr&
          ELSE
             ErrorCode 9, HEX$(knorr&)
          END IF
       END IF
    END IF
 
    IF LCASE$(RIGHT$(flump$, 1)) = "b" THEN    'binr tal
       IF foundit = 0 THEN
          tmp1 = LEN(flump$): flump$ = LEFT$(flump$, tmp1 - 1)  'tar bort b
          foundit = 1
          knorr& = FromBin32(flump$)
          IF knorr& < 65536 THEN      'overflow checking
             GetTrueVal16 = knorr&
          ELSE
             ErrorCode 9, HEX$(knorr&)
          END IF
       END IF
    END IF

    IF LCASE$(RIGHT$(flump$, 1)) = "d" THEN    'decimal tal
       IF foundit = 0 THEN
          tmp1 = LEN(flump$)
          knas$ = HEX$(VAL(flump$))
          foundit = 1
          knorr& = VAL("&h" + knas$)
          IF knorr& < 65536 THEN      'overflow checking
             GetTrueVal16 = knorr&
          ELSE
             ErrorCode 9, HEX$(knorr&)
          END IF
       END IF
    END IF




    IF foundit = 0 THEN     ' antagligen vanligt decimalt tal
       tsrmp$ = LTRIM$(STR$(VAL(flump$)))
       IF tsrmp$ = flump$ THEN  ' ja vanligt decimaltal
          foundit = 1
          tmp1 = LEN(flump$)
          knas$ = HEX$(VAL(flump$))
          knorr& = VAL("&h" + knas$)
          IF knorr& < 65536 THEN      'overflow checking
             GetTrueVal16& = knorr&
          ELSE
             ErrorCode 9, HEX$(knorr&)
          END IF
       ELSE
          ErrorCode 8, flump$
       END IF
    END IF

END FUNCTION

FUNCTION GetTrueVal32& (invar$)
  
    'omvandlar frn hex-textstrng till decimalt
    'eller textstrng, eller snt :)

    foundit = 0

    flemp$ = LTRIM$(RTRIM$(invar$))
    IF LCASE$(RIGHT$(flemp$, 1)) = "h" THEN    'hex tal
       tmp1 = LEN(flemp$): flemp$ = LEFT$(flemp$, tmp1 - 1)  'tar bort h'et p slutet
       foundit = 1
       GetTrueVal32& = VAL("&h" + flemp$)
    END IF

    IF LCASE$(LEFT$(flemp$, 1)) = "$" THEN    'hex tal
       tmp1 = LEN(flemp$): flemp$ = RIGHT$(flemp$, tmp1 - 1)  'tar bort $
       foundit = 1
       GetTrueVal32& = VAL("&h" + flemp$)
    END IF


    IF LCASE$(LEFT$(flemp$, 2)) = "0x" THEN     'hex tal, C++ variant
       IF foundit = 0 THEN
          flemp$ = MID$(flemp$, 3)                   'tar bort 0x i brjan
          foundit = 1
          GetTrueVal32& = VAL("&h" + flemp$)
       END IF
    END IF
 
    IF LCASE$(RIGHT$(flemp$, 1)) = "b" THEN    'binr tal
       IF foundit = 0 THEN
          tmp1 = LEN(flemp$): flemp$ = LEFT$(flemp$, tmp1 - 1)  'tar bort b
          foundit = 1
          GetTrueVal32& = FromBin32(flemp$)
       END IF
    END IF

    IF LCASE$(RIGHT$(flemp$, 1)) = "d" THEN    'decimal tal
       IF foundit = 0 THEN
          tmp1 = LEN(flemp$): flemp$ = LEFT$(flemp$, tmp1 - 1)'tar bort b
          foundit = 1
          GetTrueVal32& = VAL(flemp$)
       END IF
    END IF

    IF foundit = 0 THEN     ' antagligen vanligt decimalt tal
       tsrmp$ = LTRIM$(STR$(VAL(flemp$)))
       IF tsrmp$ = flemp$ THEN  ' ja vanligt decimaltal
          GetTrueVal32& = VAL(flemp$)
       ELSE
          ErrorCode 8, flemp$
       END IF
    END IF


END FUNCTION

FUNCTION GetVal16$ (flump$)

    'omvandlar frn hex-textstrng till decimalt
    'eller textstrng, eller snt :)
    flump$ = LTRIM$(RTRIM$(flump$))
    IF LCASE$(RIGHT$(flump$, 1)) = "h" THEN    'hex tal
       tmp1 = LEN(flump$): flump$ = LEFT$(flump$, tmp1 - 1)  'tar bort h'et p slutet
       foundit = 1
       knorr& = VAL("&h" + flump$)
       IF knorr& < 65536 THEN      'overflow checking
          flump$ = "0000" + flump$
          flump$ = RIGHT$(flump$, 4)
          FOR a = 1 TO LEN(flump$) STEP 2
              del = VAL("&h" + MID$(flump$, a, 2))
              temp$ = temp$ + CHR$(del)
          NEXT a
          GetVal16$ = temp$
       ELSE
          ErrorCode 9, HEX$(knorr&)
       END IF
    END IF
    IF LCASE$(LEFT$(flump$, 1)) = "$" THEN    'hex tal
       tmp1 = LEN(flump$): flump$ = RIGHT$(flump$, tmp1 - 1)  'tar bort $
       foundit = 1
       knorr& = VAL("&h" + flump$)
       IF knorr& < 65536 THEN      'overflow checking
          flump$ = "0000" + flump$
          flump$ = RIGHT$(flump$, 4)
          FOR a = 1 TO LEN(flump$) STEP 2
              del = VAL("&h" + MID$(flump$, a, 2))
              temp$ = temp$ + CHR$(del)
          NEXT a
          GetVal16$ = temp$
       ELSE
          ErrorCode 9, HEX$(knorr&)
       END IF
    END IF


    IF LCASE$(LEFT$(flump$, 2)) = "0x" THEN     'hex tal, C++ variant
       IF foundit = 0 THEN
          flump$ = MID$(flump$, 3)                   'tar bort 0x i brjan
          foundit = 1
          knorr& = VAL("&h" + flump$)
          IF knorr& < 65536 THEN      'overflow checking
             flump$ = "0000" + flump$
             flump$ = RIGHT$(flump$, 4)
             FOR a = 1 TO LEN(flump$) STEP 2
                del = VAL("&h" + MID$(flump$, a, 2))
                temp$ = temp$ + CHR$(del)
             NEXT a
             GetVal16$ = temp$
          ELSE
             ErrorCode 9, HEX$(knorr&)
          END IF
       END IF
    END IF
  
    IF LCASE$(RIGHT$(flump$, 1)) = "b" THEN    'binr tal
       IF foundit = 0 THEN
          tmp1 = LEN(flump$): flump$ = LEFT$(flump$, tmp1 - 1)  'tar bort b
          foundit = 1
          knorr& = FromBin32(flump$)
          IF knorr& < 65536 THEN      'overflow checking
             knas$ = HEX$(FromBin32(flump$))
             flump$ = "0000" + flump$
             flump$ = RIGHT$(flump$, 4)
             FOR a = 1 TO LEN(knas$) STEP 2
                del = VAL("&h" + MID$(knas$, a, 2))
                temp$ = temp$ + CHR$(del)
             NEXT a
             GetVal16$ = temp$
          ELSE
             ErrorCode 9, flump$
          END IF
       END IF
    END IF

    IF LCASE$(RIGHT$(flump$, 1)) = "d" THEN    'decimal tal
       IF foundit = 0 THEN
          tmp1 = LEN(flump$)
          knas$ = HEX$(VAL(flump$))
          foundit = 1
          knorr& = VAL("&h" + knas$)
          IF knorr& < 65536 THEN      'overflow checking
             flump$ = "0000" + flump$
             flump$ = RIGHT$(flump$, 4)
             FOR a = 1 TO LEN(knas$) STEP 2
                del = VAL("&h" + MID$(knas$, a, 2))
                temp$ = temp$ + CHR$(del)
             NEXT a
             GetVal16$ = temp$
          ELSE
             ErrorCode 9, LTRIM$(STR$(knorr&))
          END IF
       END IF
    END IF



    IF foundit = 0 THEN
       IF LEFT$(flump$, 1) = CHR$(34) THEN    'text strng
          IF RIGHT$(flump$, 1) = CHR$(34) THEN    'text strng
             tmp1 = LEN(flump$)
             GetVal16$ = MID$(flump$, 2, tmp1 - 2)
          ELSE
             PRINT " ("; rad$; ") Ending " + CHR$(34) + " is missing."
          END IF
          foundit = 1
       END IF
    END IF

    IF foundit = 0 THEN     ' antagligen vanligt decimalt tal
       tsrmp$ = LTRIM$(STR$(VAL(flump$)))
       IF tsrmp$ = flump$ THEN  ' ja vanligt decimaltal
          tmp1 = LEN(flump$)
          knas$ = HEX$(VAL(flump$))
          knorr& = VAL("&h" + knas$)
          IF knorr& < 65536 THEN      'overflow checking
             knas$ = "0000" + knas$
             knas$ = RIGHT$(knas$, 4)
             FOR a = 1 TO LEN(knas$) STEP 2
                 del = VAL("&h" + MID$(knas$, a, 2))
                 temp$ = temp$ + CHR$(del)
             NEXT a
             GetVal16$ = temp$
             foundit = 1
          ELSE
             ErrorCode 9, LTRIM$(STR$(knorr&))
          END IF
       ELSE
          ErrorCode 8, flump$
       END IF
    END IF

END FUNCTION

FUNCTION GetVal32$ (invar$)

    'omvandlar frn hex-textstrng till decimalt
    'eller textstrng, eller snt :)

    foundit = 0

    flemp$ = LTRIM$(RTRIM$(invar$))
    IF LCASE$(RIGHT$(flemp$, 1)) = "h" THEN    'hex tal
       tmp1 = LEN(flemp$): flemp$ = LEFT$(flemp$, tmp1 - 1)  'tar bort h'et p slutet
       foundit = 1
       flemp$ = "0000" + flemp$
       flemp$ = RIGHT$(flemp$, 8)
       FOR a = 1 TO LEN(flemp$) STEP 2
           del = VAL("&h" + MID$(flemp$, a, 2))
           temp$ = temp$ + CHR$(del)
       NEXT a
       GetVal32$ = temp$
    END IF

    IF LCASE$(LEFT$(flemp$, 1)) = "$" THEN    'hex tal
       tmp1 = LEN(flemp$): flemp$ = RIGHT$(flemp$, tmp1 - 1)  'tar bort $
       foundit = 1
       flemp$ = "0000" + flemp$
       flemp$ = RIGHT$(flemp$, 8)
       FOR a = 1 TO LEN(flemp$) STEP 2
           del = VAL("&h" + MID$(flemp$, a, 2))
           temp$ = temp$ + CHR$(del)
       NEXT a
       GetVal32$ = temp$
    END IF


    IF LCASE$(LEFT$(flemp$, 2)) = "0x" THEN     'hex tal, C++ variant
       IF foundit = 0 THEN
          flemp$ = MID$(flemp$, 3)                   'tar bort 0x i brjan
          foundit = 1
          flemp$ = "0000" + flemp$
          flemp$ = RIGHT$(flemp$, 8)
          FOR a = 1 TO LEN(flemp$) STEP 2
              del = VAL("&h" + MID$(flemp$, a, 2))
              temp$ = temp$ + CHR$(del)
          NEXT a
          GetVal32$ = temp$
       END IF
    END IF
  
    IF LCASE$(RIGHT$(flemp$, 1)) = "b" THEN    'binr tal
       IF foundit = 0 THEN
          tmp1 = LEN(flemp$): flemp$ = LEFT$(flemp$, tmp1 - 1)  'tar bort b
          foundit = 1
          knas$ = HEX$(FromBin32(flemp$))
          flemp$ = "0000" + flemp$
          flemp$ = RIGHT$(flemp$, 32)
          FOR a = 1 TO LEN(knas$) STEP 2
              del = VAL("&h" + MID$(knas$, a, 2))
              temp$ = temp$ + CHR$(del)
          NEXT a
          GetVal32$ = temp$
       END IF
    END IF

    IF LCASE$(RIGHT$(flemp$, 1)) = "d" THEN    'decimal tal
       IF foundit = 0 THEN
          tmp1 = LEN(flemp$)
          knas$ = HEX$(VAL(flemp$))
          foundit = 1
          flemp$ = "0000" + flemp$
          flemp$ = RIGHT$(flemp$, 8)
          FOR a = 1 TO LEN(knas$) STEP 2
              del = VAL("&h" + MID$(knas$, a, 2))
              temp$ = temp$ + CHR$(del)
          NEXT a
          GetVal32$ = temp$
       END IF
    END IF

    IF foundit = 0 THEN
       IF LEFT$(flemp$, 1) = CHR$(34) THEN    'text strng
          IF RIGHT$(flemp$, 1) = CHR$(34) THEN    'text strng
             tmp1 = LEN(flemp$)
             GetVal32$ = MID$(flemp$, 2, tmp1 - 2)
          ELSE
             PRINT " ("; rad$; ") Ending " + CHR$(34) + " is missing."
          END IF
          foundit = 1
       END IF
    END IF

    IF foundit = 0 THEN     ' antagligen vanligt decimalt tal
       tsrmp$ = LTRIM$(STR$(VAL(flemp$)))
       IF tsrmp$ = flemp$ THEN  ' ja vanligt decimaltal
          tmp1 = LEN(flemp$)
          knas$ = HEX$(VAL(flemp$))
          knorr& = VAL("&h" + knas$)

             knas$ = "0000" + knas$
             knas$ = RIGHT$(knas$, 4)
             FOR a = 1 TO LEN(knas$) STEP 2
                 del = VAL("&h" + MID$(knas$, a, 2))
                 temp$ = temp$ + CHR$(del)
             NEXT a
             GetVal32$ = temp$
             foundit = 1
       ELSE
          ErrorCode 8, flemp$
       END IF
    END IF

END FUNCTION

FUNCTION GetValue16$ (flump$)

   '1. kolla om det r +-*/ i strngen
   '  1a. dela upp i 2 delar
   '  1b. kalkylera
   '2. omvandla till tal

  
   vrump1 = CountStr(flump$, "+")
   vrump2 = CountStr(flump$, "-")
   vrump3 = CountStr(flump$, "*")
   vrump4 = CountStr(flump$, "/")
   vjamp = vrump1 + vrump2 + vrump3 + vrump4
   IF vjamp > 0 THEN
      IF vjamp > 1 THEN
         ErrorCode 11, flump$
         'PRINT "fel kalkulatiklsgfd "; flump$'
      ELSE
        IF vrump1 THEN  'plus
           vrump1 = INSTR(flump$, "+")
           del1$ = LEFT$(flump$, vrump1 - 1)
           del2$ = MID$(flump$, vrump1 + 1)
           del1a& = GetTrueVal16(del1$)
           del2a& = GetTrueVal16(del2$)
           svaret& = del1a& + del2a&
           flump$ = LTRIM$(STR$(svaret&))
        END IF
        IF vrump2 THEN  'minus
           IF INSTR(flump$, "-") > 1 THEN ' om 1 s r indikerar det ett minustal
              vrump2 = INSTR(flump$, "-")
              del1$ = LEFT$(flump$, vrump2 - 1)
              del2$ = MID$(flump$, vrump2 + 1)
              del1a& = GetTrueVal16(del1$)
              del2a& = GetTrueVal16(del2$)
              svaret& = del1a& - del2a&
              flump$ = LTRIM$(STR$(svaret&))
           ELSE
              done1& = GetTrueVal16(flump$)
              GetValue16$ = STR$(done1&)
           END IF
        END IF
        IF vrump3 THEN  'gnger
           vrump3 = INSTR(flump$, "*")
           del1$ = LEFT$(flump$, vrump3 - 1)
           del2$ = MID$(flump$, vrump3 + 1)
           del1a& = GetTrueVal16(del1$)
           del2a& = GetTrueVal16(del2$)
           svaret& = del1a& * del2a&
           flump$ = LTRIM$(STR$(svaret&))
        END IF
        IF vrump4 THEN  'delat med
           vrump4 = INSTR(flump$, "/")
           del1$ = LEFT$(flump$, vrump4 - 1)
           del2$ = MID$(flump$, vrump4 + 1)
           del1a& = GetTrueVal16(del1$)
           del2a& = GetTrueVal16(del2$)
           svaret& = del1a& / del2a&
           flump$ = LTRIM$(STR$(svaret&))
        END IF
        done1& = GetTrueVal16(flump$)
        GetValue16$ = STR$(done1&)
      END IF
   ELSE
      done1& = GetTrueVal16(flump$)
      GetValue16$ = STR$(done1&)
   END IF

END FUNCTION

FUNCTION GetValue32$ (flump$)


   '1. kolla om det r +-*/ i strngen
   '  1a. dela upp i 2 delar
   '  1b. kalkylera
   '2. omvandla till tal

   vrump1 = CountStr(flump$, "+")
   vrump2 = CountStr(flump$, "-")
   vrump3 = CountStr(flump$, "*")
   vrump4 = CountStr(flump$, "/")
   vjamp = vrump1 + vrump2 + vrump3 + vrump4
   IF vjamp > 0 THEN
      IF vjamp > 1 THEN
         ErrorCode 11, flump$
         'PRINT "fel kalkulatiklsgfd "; flump$'
      ELSE
         IF vrump1 THEN  'plus
           tmp = INSTR(flump$, "+")
           del1$ = LEFT$(flump$, tmp - 1)
           del2$ = MID$(flump$, tmp + 1)
           del1a& = GetTrueVal32(del1$)
           del2a& = GetTrueVal32(del2$)
           svaret& = del1a& + del2a&
           flump$ = LTRIM$(STR$(svaret&))
         END IF
         IF vrump2 THEN  'minus
            tmp = INSTR(flump$, "-")
            del1$ = LEFT$(flump$, tmp - 1)
            del2$ = MID$(flump$, tmp + 1)
            del1a& = GetTrueVal32(del1$)
            del2a& = GetTrueVal32(del2$)
            svaret& = del1a& - del2a&
            flump$ = LTRIM$(STR$(svaret&))
         END IF
         IF vrump3 THEN  'gnger
            tmp = INSTR(flump$, "*")
            del1$ = LEFT$(flump$, tmp - 1)
            del2$ = MID$(flump$, tmp + 1)
            del1a& = GetTrueVal32(del1$)
            del2a& = GetTrueVal32(del2$)
            svaret& = del1a& * del2a&
            flump$ = LTRIM$(STR$(svaret&))
         END IF
         IF vrump4 THEN  'delat med
            tmp = INSTR(flump$, "/")
            del1$ = LEFT$(flump$, tmp - 1)
            del2$ = MID$(flump$, tmp + 1)
            del1a& = GetTrueVal32(del1$)
            del2a& = GetTrueVal32(del2$)
            svaret& = del1a& / del2a&
            flump$ = LTRIM$(STR$(svaret&))
         END IF
         done1& = GetTrueVal32(flump$)
         GetValue32$ = STR$(done1&)
      END IF
   ELSE
      done1& = GetTrueVal32(flump$)
      GetValue32$ = STR$(done1&)
   END IF

END FUNCTION

SUB HalfBlock
   
    'vet inte hur mnga delar det finns i db blocket, s jag rknar alla
    ' kommatecken ",":

    paramcnt = 0
    FOR a = 1 TO LEN(param$)
        jos$ = MID$(param$, a, 1)
        IF jos$ = "," THEN paramcnt = paramcnt + 1
    NEXT a
  
    SplitParam param$, paramcnt + 1: known = 1
   
    IF ParamErr = 0 THEN
       FOR a = 1 TO paramcnt + 1  'dumpar varje dword
           opcode$ = GetVal16(parameter$(a))
           opcode$ = CHR$(0) + CHR$(0) + opcode$
           opcode$ = RIGHT$(opcode$, 2)
           PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 2
       NEXT a
    END IF

END SUB

SUB HandleDirective

    known = 1
    ErrorCode 12, param$


END SUB

SUB IncludeBin
      
      
    IncBinFile$ = GetByteValue(param$): known = 1

    IF IncBinFile$ <> "" THEN
       ErrFile$ = IncBinFile$
       OPEN ErrFile$ FOR BINARY AS #5
      
       IncBinLen& = LOF(5)
       IF IncBinLen& = 0 THEN
          PRINT "file not exist"
          CLOSE #5
          IF DebugMode = 0 THEN KILL IncBinFile$
       ELSE
          PRINT "      Including binary file "; UCASE$(IncBinFile$); " ("; LTRIM$(STR$(IncBinLen&)); " bytes)... ";
          RestCode& = MainCode&
          IncPoint& = &H1
          towrite# = IncBinLen&
          DO
             IF towrite# > 7000 THEN
                tmp$ = SPACE$(7000)
                GET #5, IncPoint&, tmp$
                PUT #2, RestCode&, tmp$
                RestCode& = RestCode& + 7000
                IncPoint& = IncPoint& + 7000
                towrite# = towrite# - 7000
             ELSE
                tmp$ = SPACE$(towrite#)
                GET #5, IncPoint&, tmp$
                PUT #2, RestCode&, tmp$
                endvillkor = 1
             END IF
          LOOP UNTIL endvillkor = 1
          PRINT "Done."
          MainCode& = RestCode&
          CLOSE #5

       END IF
       

 
    END IF


               
                


END SUB

SUB InsertBlock

    SplitParam param$, 2: known = 1
    IF ParamErr = 0 THEN
       totlen& = VAL(GetValue16(parameter$(1)))
       charEn = VAL(GetValue16(parameter$(2)))

       endvillkor = 0
       IF totlen& > 0 THEN
          PRINT "      Inserting"; totlen&; "bytes... ";
          RestCode& = MainCode&
          DO
             towrite# = totlen&
             IF towrite# > 7000 THEN
                tmp$ = STRING$(7000, CHR$(charEn))
                PUT #2, RestCode&, tmp$
                RestCode& = RestCode& + 7000
                totlen& = totlen& - 7000
             ELSE
                tmp$ = STRING$(towrite#, CHR$(charEn))
                PUT #2, RestCode&, tmp$
                endvillkor = 1
             END IF
          LOOP UNTIL endvillkor = 1
          PRINT "Done."
       END IF

  
    END IF



END SUB

SUB PseudoType1 (xxx$)

    SplitParam param$, 2: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "000000" + "00000" + ValidReg(parameter$(2))
       tmpYY$ = ValidReg(parameter$(1)) + "00000" + xxx$
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB PseudoType2 (xxx$)
   
    'bnez rs,offset
    'compiles buggy code

    SplitParam param$, 2: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = xxx$ + ValidReg(parameter$(1)) + "00000"

       value = GetAdr(parameter$(2))
       BranchVal$ = GetBranchVal(value&)

       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + BranchVal$
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB PseudoType3 (xxx$)
   
    'negu rd, rs

    SplitParam param$, 2: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "000000" + "00000" + ValidReg(parameter$(2))
       tmpYY$ = ValidReg(parameter$(1)) + "00000" + xxx$
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB PseudoType4 (xxx$)

    SplitParam param$, 1: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = xxx$ + "00000" + "00000"

       value = GetAdr(parameter$(1))
       BranchVal$ = GetBranchVal(value&)

       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + BranchVal$
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB PseudoType5 (xxx$)
   
    SplitParam param$, 1: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = xxx$ + "00000" + xxx$

       value = GetAdr(parameter$(1))
       BranchVal$ = GetBranchVal(value&)

       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + BranchVal$
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB PseudoType6 (xxx$)
   
    SplitParam param$, 2: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = xxx$ + "00000" + ValidReg(parameter$(1))
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + FixVal16(parameter$(2))

       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

FUNCTION RemoveTrash$ (txt$)
   
    OutDelen$ = ""
    FOR vaa = 1 TO LEN(txt$)
      juka$ = MID$(txt$, vaa, 1)
      IF juka$ = CHR$(9) THEN juka$ = " "
      
      OutDelen$ = OutDelen$ + juka$
    NEXT vaa
   
    RemoveTrash = OutDelen$

END FUNCTION

SUB SetStartVars

  Version$ = "Nintendo 64 ToolKit: R4300i assembler v0.1a by anarko <anarko@flashback.net>"
  Reg$(0) = "r0":  Reg$(8) = "t0": Reg$(16) = "s0": Reg$(24) = "t8"
  Reg$(1) = "at":  Reg$(9) = "t1": Reg$(17) = "s1": Reg$(25) = "t9"
  Reg$(2) = "v0": Reg$(10) = "t2": Reg$(18) = "s2": Reg$(26) = "k0"
  Reg$(3) = "v1": Reg$(11) = "t3": Reg$(19) = "s3": Reg$(27) = "k1"
  Reg$(4) = "a0": Reg$(12) = "t4": Reg$(20) = "s4": Reg$(28) = "gp"
  Reg$(5) = "a1": Reg$(13) = "t5": Reg$(21) = "s5": Reg$(29) = "sp"
  Reg$(6) = "a2": Reg$(14) = "t6": Reg$(22) = "s6": Reg$(30) = "s8"
  Reg$(7) = "a3": Reg$(15) = "t7": Reg$(23) = "s7": Reg$(31) = "ra"
  FOR a = 0 TO 31: Reg2$(a) = "reg" + LTRIM$(STR$(a)): NEXT a
  FOR a = 0 TO 31: Reg3$(a) = "r" + LTRIM$(STR$(a)): NEXT a
  FOR a = 0 TO 31
      IF a < 10 THEN
         Reg4$(a) = "r0" + LTRIM$(STR$(a))
      ELSE
         Reg4$(a) = "r" + LTRIM$(STR$(a))
      END IF
  NEXT a

  FReg$(0) = "index": FReg$(1) = "random": FReg$(2) = "entrylo0"
  FReg$(3) = "entrylo1": FReg$(4) = "context": FReg$(5) = "pagemask"
  FReg$(6) = "wired": FReg$(7) = "": FReg$(8) = "badvaddr"
  FReg$(9) = "count": FReg$(10) = "entryhi": FReg$(11) = "compare"
  FReg$(12) = "status": FReg$(13) = "cause": FReg$(14) = "epc"
  FReg$(15) = "previd": FReg$(16) = "config": FReg$(17) = "lladdr"
  FReg$(18) = "watchlo": FReg$(19) = "watchhi": FReg$(20) = "xcontext"
  FReg$(21) = "": FReg$(22) = "": FReg$(23) = "": FReg$(24) = ""
  FReg$(25) = "": FReg$(26) = "perr": FReg$(27) = "cacheerr"
  FReg$(28) = "taglo": FReg$(29) = "taghi": FReg$(30) = "errorepc"
  FReg$(31) = ""
  FOR a = 0 TO 31
      IF a < 10 THEN
         FReg2$(a) = "c0" + LTRIM$(STR$(a))
      ELSE
         FReg2$(a) = "c" + LTRIM$(STR$(a))
      END IF
  NEXT a



  FOR a = 0 TO 31: CP2Reg$(a) = "fp" + LTRIM$(STR$(a)): NEXT a
  FOR a = 0 TO 31: CP2BReg$(a) = "f" + LTRIM$(STR$(a)): NEXT a

END SUB

FUNCTION shl# (var&, steps)

   'lgger till "steps" antal "0" p hgersidan av binrtalet

   fftmp$ = ToBin16$(var&)

   FOR kaka = 1 TO steps + 1
       fftmp$ = RIGHT$(fftmp$, 15) + "0"
   NEXT kaka
   shl# = FromBin32(fftmp$)

END FUNCTION

SUB ShowSyntax (txt$)

    PRINT "  Syntax: N64ASM [options] <filename.asm>"
    PRINT
    PRINT " -byteswap  Byteswaps image (def=OFF)"
    PRINT " -header    Creates a header for the image (def=OFF)"
    PRINT " -keepfile  Does not delete the outfile if errors occours (def=OFF)"
    PRINT " -equXX     Checks each line after EQU's XX times (def=2)"
    PRINT " -errXX     Stops assembling after XX errors (def=100)"
    PRINT " -alignX    Stores null-bytes till address is divisible by 2, 4 or 8 (def=4)"
    

   
    IF txt$ <> "" THEN
       PRINT
       PRINT " Unknown option: "; txt$
    END IF
   
    END

END SUB

FUNCTION shr# (var&, steps)
   'lgger till "steps" antal "0" p vnstersidan av binrtalet

   
   fftmp$ = ToBin16$(var&)

   fftmp$ = STRING$(steps, "0") + fftmp$
   fftmp$ = LEFT$(fftmp$, 16)
   
   shr# = FromBin32(fftmp$)

END FUNCTION

SUB SplitParam (some$, trams)
    
     fiasko = INSTR(some$, "^__^")
     IF fiasko > 0 THEN
        IF LabelCnt& < 1000 THEN
           Label$(LabelCnt&) = MID$(some$, fiasko + 8) + STR$(MainCode& - 1)
           LabelCnt& = LabelCnt& + 1
           some$ = RTRIM$(LEFT$(some$, fiasko - 1))
        ELSE
         'PRINT "label slut.. :-("; inst$
         EXIT SUB
        END IF
     END IF
    
     skit$ = some$ + ","
     parcnt = 0: ParamErr = 0
    
     FOR a = 1 TO 4
         parameter$(a) = ""
     NEXT a
    
     DO
        tmp = INSTR(skit$, ",")
        utklippt$ = MID$(skit$, 1, tmp - 1)
        skit$ = MID$(skit$, tmp + 1)
        parcnt = parcnt + 1
        parameter$(parcnt) = LTRIM$(utklippt$)
     LOOP WHILE INSTR(skit$, ",") <> 0
     
     IF RIGHT$(utklippt$, 1) = ")" THEN
        ttt = LEN(utklippt$)
        nytt$ = LEFT$(utklippt$, ttt - 1)
        ful = INSTR(nytt$, "(")
        IF ful > 0 THEN
           del1$ = LEFT$(nytt$, ful - 1)
           del2$ = MID$(nytt$, ful + 1)
           parameter$(parcnt) = del2$
           parcnt = parcnt + 1
           parameter$(parcnt) = LTRIM$(del1$)
        ELSE
           PRINT " ("; rad$; ") Missing ("
        END IF
     END IF

     ParameterCNT = parcnt
     IF trams < ParameterCNT THEN
        tmp$ = LTRIM$(STR$(ParameterCNT)) + " found," + STR$(trams) + " needed"
        ErrorCode 5, tmp$: ParamErr = 1
     END IF
     IF trams > ParameterCNT THEN
        tmp$ = LTRIM$(STR$(ParameterCNT)) + " found," + STR$(trams) + " needed"
        ErrorCode 6, tmp$: ParamErr = 1
     END IF

END SUB

FUNCTION ToBin16$ (word&)

   numb& = word&
   svar$ = "": cnt# = 65536 / 2
  
   FOR a = 0 TO 15
       tmp# = numb& - cnt#
       IF tmp# >= 0 THEN
          svar$ = svar$ + "1"
          numb& = tmp#
       ELSE
          svar$ = svar$ + "0"
       END IF
       cnt# = cnt# / 2
   NEXT
   ToBin16 = svar$

END FUNCTION

FUNCTION ToBin32$ (word&)

   numb& = word&
   svar$ = "": cnt# = 2 ^ 31
 
   FOR a = 0 TO 31
       tmp# = numb& - cnt#
       IF tmp# >= 0 THEN
          svar$ = svar$ + "1"
          numb& = tmp#
       ELSE
          svar$ = svar$ + "0"
       END IF
       cnt# = cnt# / 2
   NEXT
   ToBin32 = svar$

END FUNCTION

FUNCTION ToBin8$ (byte&)
  
   numb = byte&
   svar$ = "": cnt = 128

   FOR a = 0 TO 7
       tmp = numb - cnt
       IF tmp >= 0 THEN
          svar$ = svar$ + "1"
          numb = tmp
       ELSE
          svar$ = svar$ + "0"
       END IF
       cnt = cnt / 2
   NEXT
   ToBin8 = svar$

END FUNCTION

SUB Type0
   
    opcode$ = CHR$(0) + CHR$(0) + CHR$(0) + CHR$(0): known = 1
    PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4

END SUB

SUB Type1 (xxx$)

    'Type 1 = addiu rs,rt,imm          '1,2,3
    '       = cache op, offset(base)   '3,1,2

    SplitParam param$, 3: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = xxx$ + ValidReg(parameter$(2)) + ValidReg(parameter$(1))
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + FixVal16(parameter$(3))

       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF
END SUB

SUB Type10 (xxx$)

    'Type 10 = beq reg,reg,offset

    SplitParam param$, 3: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = xxx$ + ValidReg(parameter$(1)) + ValidReg(parameter$(2))

       value& = GetAdr(parameter$(3))
       BranchVal$ = GetBranchVal(value&)
      
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + BranchVal$
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type11 (xxx$)

    'Type 11 = blez rs, offset
    'buggy


    SplitParam param$, 2: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = xxx$ + ValidReg(parameter$(1)) + "00000"

       value = GetAdr(parameter$(2))
       BranchVal$ = GetBranchVal(value&)

       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + BranchVal$
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type12 (xxx$)
   
    'Type 12 = mfc0 rt, fs   (COP0)
  
    SplitParam param$, 2: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "010000" + xxx$ + ValidReg(parameter$(1))
       tmpYY$ = ValidFReg(parameter$(2)) + "00000000000"
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type13 (xxx$)
   
    'Type 13 = ERET, TLBR etc..
    
    known = 1
    
    tmpXX$ = "010000" + "0" + "000000000"
    tmpYY$ = "0000000000" + xxx$
    opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
    PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4

END SUB

SUB Type14 (xxx$)

    'Type 14 = mtc1 rt, fs     (COP1)

    SplitParam param$, 2: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "010001" + xxx$ + ValidReg(parameter$(1))
       tmpYY$ = ValidFReg(parameter$(2)) + "00000000000"
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type15 (xxx$)

    'Type 15 = mfc2 rt, fs      (COP2)

    SplitParam param$, 2: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "010010" + xxx$ + ValidReg(parameter$(1))
       tmpYY$ = ValidCP2Reg(parameter$(2)) + "00000000000"
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type16 (xxx$)

    'Type 16 = BC0F offset  (COP0)
 
    SplitParam param$, 1: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "010000" + "01000" + "000" + xxx$
       tmpYY$ = FixVal16(parameter$(1))
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF
END SUB

SUB Type17 (xxx$)
   
    'Type 17 = BC1F offset  (COP1)

    SplitParam param$, 1: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "010001" + "01000" + "000" + xxx$

       value& = GetAdr(parameter$(1))
       BranchVal$ = GetBranchVal(value&)
       
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + BranchVal$
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type18 (xxx$)
   
    'Type 18 = sync
  
    SplitParam param$, 1: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "000000" + "0000000000"
       tmpYY$ = "00000" + "00000" + xxx$
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type19 (xxx$)
   
    'Type 19 = jalr rs, rd
 
    SplitParam param$, 2: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "000000" + ValidReg(parameter$(1)) + "00000"
       tmpYY$ = ValidReg(parameter$(2)) + "00000" + xxx$
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type2 (xxx$)

    'Type 2 = lui rt, immediate

    SplitParam param$, 2: known = 1
    IF ParamErr = 0 THEN
       opcode$ = CHR$(FromBin(xxx$ + "00")) + CHR$(FromBin("000" + ValidReg(parameter$(1)))) + FixVal16(parameter$(2))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type20 (xxx$)
   
    'Type 20 = add.s  (SINGLE!) (cop1)
 
    SplitParam param$, 3: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "010001" + "10000" + ValidFReg(parameter$(3))
       tmpYY$ = ValidFReg(parameter$(2)) + ValidFReg(parameter$(1)) + xxx$
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF
END SUB

SUB Type21 (xxx$)
   
    'Type 21 = add.d  (DOUBLE!) (cop1)

    SplitParam param$, 3: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "010001" + "10001" + ValidFReg(parameter$(3))
       tmpYY$ = ValidFReg(parameter$(2)) + ValidFReg(parameter$(1)) + xxx$
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type22 (xxx$)
   
    'Type 22 = abs.s  (SINGLE!) (cop1)

    SplitParam param$, 2: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "010001" + "10000" + "00000"
       tmpYY$ = ValidFReg(parameter$(2)) + ValidFReg(parameter$(1)) + xxx$
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type23 (xxx$)
   
    'Type 23 = abs.d  (double!) (cop1)

    SplitParam param$, 2: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "010001" + "10001" + "00000"
       tmpYY$ = ValidFReg(parameter$(2)) + ValidFReg(parameter$(1)) + xxx$
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type24 (xxx$)
   
    'Type 24 = cvt.s.w  (word!) (cop1)

    SplitParam param$, 2: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "010001" + "10100" + "00000"
       tmpYY$ = ValidFReg(parameter$(2)) + ValidFReg(parameter$(1)) + xxx$
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type25 (xxx$)
   
    'Type 25 = cvt.s.l  (long!) (cop1)

    SplitParam param$, 2: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "010001" + "10101" + "00000"
       tmpYY$ = ValidFReg(parameter$(2)) + ValidFReg(parameter$(1)) + xxx$
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type26 (xxx$)
   
    'Type 26 = BC2F offset  (COP2)

    SplitParam param$, 1: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "010010" + "01000" + "000" + xxx$
       tmpYY$ = FixVal16(parameter$(1))
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type27 (xxx$)

    'Type 27 = C.cond.S (single!) COP1

    SplitParam param$, 2: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "010001" + "10000" + ValidFReg(parameter$(2))
       tmpYY$ = ValidFReg(parameter$(1)) + "000" + "0011" + xxx$
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type28 (xxx$)
   
    'Type 28 = C.cond.D (double!) COP1

    SplitParam param$, 2: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "010001" + "10001" + ValidFReg(parameter$(2))
       tmpYY$ = ValidFReg(parameter$(1)) + "000" + "0011" + xxx$
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type29 (xxx$)

    'Type 29 = tge rs, rt
 
    SplitParam param$, 2: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "000000" + ValidReg(parameter$(1)) + ValidReg(parameter$(2))
       tmpYY$ = "0000000000" + xxx$
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type3 (xxx$)

    'Type 3 = srav rd, rt, rs

    SplitParam param$, 3: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "000000" + ValidReg(parameter$(2)) + ValidReg(parameter$(3))
       tmpYY$ = ValidReg(parameter$(1)) + "00000" + xxx$
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type30 (xxx$)
   
    'Type 30 = break offset    (20 bits)

    SplitParam param$, 1: known = 1
    IF parameter$(1) <> "" THEN
       IF ParamErr = 0 THEN
          value& = GetAdr(parameter$(1))
          BranchVal$ = GetBranchValBREAK(value&)
         
          tmp11$ = "000000" + BranchVal$ + xxx$
          tmpXX$ = LEFT$(tmp11$, 16)
          tmpYY$ = RIGHT$(tmp11$, 16)
         
          opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
          PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
       END IF
    ELSE
       tmp11$ = "000000" + STRING$(20, "0") + xxx$
       tmpXX$ = LEFT$(tmp11$, 16)
       tmpYY$ = RIGHT$(tmp11$, 16)

       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF


END SUB

SUB Type31 (xxx$)

    'Type 31 = teqi rs, immediate
  
  
    SplitParam param$, 2: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "000001" + ValidReg(parameter$(1)) + xxx$

       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + FixVal16(parameter$(2))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type32 (xxx$)

    SplitParam param$, 3: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = xxx$ + ValidReg(parameter$(2)) + ValidFReg(parameter$(1))
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + FixVal16(parameter$(3))

       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type4 (xxx$)

    'Type 4 = sll rd, rt, sa

    SplitParam param$, 3: known = 1
    IF ParamErr = 0 THEN
       ToBin5$ = RIGHT$(ToBin8(VAL(parameter$(3))), 5)
       tmpXX$ = "000000" + "00000" + ValidReg(parameter$(2))
       tmpYY$ = ValidReg(parameter$(1)) + ToBin5$ + xxx$
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type5 (xxx$)

    'Type 5 = mult rs, rt
   
    SplitParam param$, 2: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "000000" + ValidReg(parameter$(1)) + ValidReg(parameter$(2))
       tmpYY$ = "0000000000" + xxx$
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type6 (xxx$)

    'Type 6 = mfhi rd
   
    SplitParam param$, 1: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "0000000000000000"
       tmpYY$ = ValidReg(parameter$(1)) + "00000" + xxx$
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type7 (xxx$)

    'Type 7 = mthi rs
   
    SplitParam param$, 1: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "000000" + ValidReg(parameter$(1)) + "00000"
       tmpYY$ = "0000000000" + xxx$
       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + CHR$(FromBin(LEFT$(tmpYY$, 8))) + CHR$(FromBin(RIGHT$(tmpYY$, 8)))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type8 (xxx$)

    'Type 8 = J target, JAL target
    'compiles buggy output

    SplitParam param$, 1: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = xxx$ + "00"
       value& = GetAdr(parameter$(1)) * 4
       
       value& = shr(value&, 1)
       flurp& = ((OrgAdr& - &H80000000) / 4) + ((value& + 6) / 4)
      
       IF flurp& < 0 THEN
          blur$ = "11"
          blur2$ = "FFFFFF"
       ELSE
          blur$ = "00"
          blur2$ = "000000"
       END IF
       bra$ = blur2$ + HEX$(flurp&)   '-12  = FFF4
       bra$ = RIGHT$(bra$, 6)
      
       bra1$ = MID$(bra$, 1, 2)
       bra2$ = MID$(bra$, 3, 2)
       bra3$ = MID$(bra$, 5, 2)
       
       opcode$ = CHR$(FromBin(xxx$ + blur$)) + CHR$(VAL("&h" + bra1$)) + CHR$(VAL("&h" + bra2$)) + CHR$(VAL("&h" + bra3$))
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

SUB Type9 (xxx$)

    'Type 9 = bltz rs, offset
    'buggy

   
    SplitParam param$, 2: known = 1
    IF ParamErr = 0 THEN
       tmpXX$ = "000001" + ValidReg(parameter$(1)) + xxx$
      
       value& = GetAdr(parameter$(2))
       BranchVal$ = GetBranchVal(value&)

       opcode$ = CHR$(FromBin(LEFT$(tmpXX$, 8))) + CHR$(FromBin(RIGHT$(tmpXX$, 8))) + BranchVal$
       PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
    END IF

END SUB

FUNCTION ValidCP2Reg$ (txt$)
  
    txt$ = LTRIM$(RTRIM$(LCASE$(txt$)))

    ttx = ASC(LEFT$(txt$, 1))
    ItIsAReg = 0
    IF ttx > 64 AND ttx < 91 THEN ItIsAReg = 1   'A-Z
    IF ttx > 96 AND ttx < 123 THEN ItIsAReg = 1  'a-z
    IF ItIsAReg = 0 THEN
      'hittat ett direkt tal, konvertera
      hittad& = VAL(GetValue16(txt$))
    ELSE
      hittad& = -1
      FOR a = 0 TO 31
          IF LCASE$(CP2Reg$(a)) = txt$ THEN
             hittad& = a
             EXIT FOR
          END IF
      NEXT a
    END IF
     
    IF hittad& = -1 THEN
       ErrorCode 1, txt$
    ELSE
       ValidCP2Reg$ = RIGHT$(ToBin8(hittad&), 5)
    END IF
    

END FUNCTION

FUNCTION ValidFReg$ (txt$)
  
    txt$ = LTRIM$(RTRIM$(LCASE$(txt$)))

    ttx = ASC(LEFT$(txt$, 1))
    ItIsAReg = 0
    IF ttx > 64 AND ttx < 91 THEN ItIsAReg = 1   'A-Z
    IF ttx > 96 AND ttx < 123 THEN ItIsAReg = 1  'a-z
    IF ItIsAReg = 0 THEN
      'hittat ett direkt tal, konvertera
      hittad& = VAL(GetValue16(txt$))
    ELSE
      hittad& = -1
      FOR a = 0 TO 31
          IF LCASE$(FReg$(a)) = txt$ THEN
             hittad& = a
             EXIT FOR
          END IF
      NEXT a
      IF hittad& = -1 THEN
         FOR a = 0 TO 31
             IF LCASE$(FReg2$(a)) = txt$ THEN
                hittad& = a
                EXIT FOR
             END IF
         NEXT a
      END IF
      IF hittad& = -1 THEN
         FOR a = 0 TO 31
             IF LCASE$(CP2Reg$(a)) = txt$ THEN
                hittad& = a
                EXIT FOR
             END IF
         NEXT a
      END IF
      IF hittad& = -1 THEN
         FOR a = 0 TO 31
             IF LCASE$(CP2BReg$(a)) = txt$ THEN
                hittad& = a
                EXIT FOR
             END IF
         NEXT a
      END IF
    END IF
   
    IF hittad& = -1 THEN
       ErrorCode 1, txt$
    ELSE
       ValidFReg$ = RIGHT$(ToBin8(hittad&), 5)
    END IF

END FUNCTION

FUNCTION ValidReg$ (txt$)
   
    txt$ = LTRIM$(RTRIM$(LCASE$(txt$)))


    ttx = ASC(LEFT$(txt$, 1))
    ItIsAReg = 0
    IF ttx > 64 AND ttx < 91 THEN ItIsAReg = 1   'A-Z
    IF ttx > 96 AND ttx < 123 THEN ItIsAReg = 1  'a-z
    IF ItIsAReg = 0 THEN
      'hittat ett direkt tal, konvertera
      hittad& = VAL(GetValue16(txt$))
    ELSE
       hittad& = -1
       FOR a = 0 TO 31
           IF LCASE$(Reg$(a)) = txt$ THEN
              hittad& = a
              EXIT FOR
           END IF
       NEXT a
       IF hittad& = -1 THEN
          FOR a = 0 TO 31
              IF LCASE$(Reg2$(a)) = txt$ THEN
                 hittad& = a
                 EXIT FOR
              END IF
          NEXT a
       END IF
       IF hittad& = -1 THEN
          FOR a = 0 TO 31
              IF LCASE$(Reg3$(a)) = txt$ THEN
                 hittad& = a
                 EXIT FOR
              END IF
          NEXT a
       END IF
       IF hittad& = -1 THEN
          FOR a = 0 TO 31
              IF LCASE$(Reg4$(a)) = txt$ THEN
                 hittad& = a
                 EXIT FOR
              END IF
          NEXT a
       END IF
       IF hittad& = -1 THEN
          IF txt$ = "zero" THEN hittad& = 0
          IF txt$ = "rzero" THEN hittad& = 0
       END IF
    END IF

    IF hittad& = -1 THEN
       ErrorCode 1, txt$
    ELSE
       ValidReg$ = RIGHT$(ToBin8(hittad&), 5)
    END IF


END FUNCTION

SUB WordBlock
    'vet inte hur mnga delar det finns i db blocket, s jag rknar alla
    ' kommatecken ",":

    paramcnt = 0
    FOR a = 1 TO LEN(param$)
        jos$ = MID$(param$, a, 1)
        IF jos$ = "," THEN paramcnt = paramcnt + 1
    NEXT a
   
    SplitParam param$, paramcnt + 1: known = 1
    
    IF ParamErr = 0 THEN
       FOR a = 1 TO paramcnt + 1  'dumpar varje dword
           opcode$ = GetVal32(parameter$(a))
           opcode$ = CHR$(0) + CHR$(0) + CHR$(0) + CHR$(0) + opcode$
           opcode$ = RIGHT$(opcode$, 4)
           PUT #2, MainCode&, opcode$: MainCode& = MainCode& + 4
       NEXT a
    END IF

END SUB

